// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/driver/main.h $
// $Rev: 53399 $
// $Date: 2023-07-12 12:04:34 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Device Driver: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include "hpdi32.h"

#define	DEV_BAR_SHOW						0
#define	DEV_METRICS_SHOW					0
#define	DEV_PCI_ID_SHOW						0
#define	DEV_SUPPORTS_IRQ
#define	DEV_SUPPORTS_PROC_ID_STR
#define	DEV_SUPPORTS_READ
#define	DEV_SUPPORTS_WAIT
#define	DEV_SUPPORTS_WRITE
#define	GSC_ALT_DEV_GET(a)					(a)
#define	GSC_ALT_STRUCT_GET(i,d)				(d)
#define	GSC_ALT_STRUCT_T					dev_data_t
#define	GSC_DEVS_PER_BOARD					1

typedef struct _dev_data_t					dev_data_t;

#include "gsc_main.h"



// macros *********************************************************************

#define	DEV_MODEL							HPDI32_BASE_NAME_UC
#define	DEV_NAME							HPDI32_BASE_NAME_LC
#define	DEV_NAME_LC							HPDI32_BASE_NAME_LC
#define	DEV_NAME_UC							HPDI32_BASE_NAME_UC

#define	DEV_VERSION_STR						GSC_STR(DEV_VERSION_MAJ_NUM) "." GSC_STR(DEV_VERSION_MIN_NUM)
#define	DEV_VERSION							DEV_VERSION_STR

#define	DEV_VERSION_MAJ_NUM					3	// FOR DEVICE SPECIFIC CODE ONLY!
#define	DEV_VERSION_MIN_NUM					12	// FOR DEVICE SPECIFIC CODE ONLY!
// 3.12	Updated to support the 6.x series kernel.
//		Added support for Fast FIFO Resets.
//		Updated the initialize IOCTL service for consistency.
// 3.11	Updated comments for consistency.
// 3.10	Made correct to a version comment.
//		Standardized various IOCTL system log messages.
//		Standardized processing of the initialization IOCTL service.
//		Some file reorganization.
//		Updatred I/O to account for I/O code reorganization and segragation.
// 3.9	Added code to distinguish the HPDI32B from the HPDI32A.
// 3.8	Added the HPDI32_GPIO_D32_OUTPUT IOCTL service.
//		Added metrics support.
// 3.7	Updated I/O code to support porting to PLX driver version 7.2.5 under Windows.
// 3.6	Fixed code in which open succeeds even if initialization fails.
//		Added Tx & Rx DMA Threshold.
//		Changed Tx & Rx FIFO Size cache field names for clarity.
//		Added support for the Windows PLX based Driver Interface Library.
//		Updated logic to check for updated TFWR & RFWR logic.
// 3.5	Added support for the 5.x kernel series.
//		Added Endianness support.
// 3.4	Modified code so open succeeds even if initialization fails.
//		Updated per changes to common I/O code.
//		Renamed Block Mode DMA macros.
// 3.3	Bug fix: was ignoring BAR setup return value.
//		Updated per changes to the OS specific PCI services.
//		Updated per changes to the low level register interface.
//		Updated to use the newer common driver sources.
//		Made updates for DEV_SUPPORTS_XXX macro changes.
// 3.2	Added an infinite I/O timeout option.
//		Corrected the IOCTL code for the register write and mod services.
// 3.1	Made PCI registers accessible from inside an ISR.
//		The BAR code has been updated to include the data under a single structure.
//		The register definitions have been updated.
//		I/O services now pass around an os_mem_t structure instead of a buffer pointer.
//		White space cleanup.
//		Changed the arbitrary wait event callback argument to a void* type.
//		Modified to allow multiple apps to simultaneously access a single device.
//		Fixed access rights to BAR0 and BAR1.
// 3.0	Updated to use the newer common driver sources.
//		Fixed a bug in the dev_read_startup() service.
//		Updated the dev_write_startup() service.
//		Removed GNU notice from non-Linux specific files.
//		Removed Linux specific content from non-Linux specific source files.
//		White space cleanup.
//		Now using a spinlock rather than enabling and disabling interrupts.
//		Updated gsc_irq_open() and gsc_irq_close().
//		Updated gsc_dma_open() and gsc_dma_close().
// 2.11	Added the GPIO D32 query related options.
//		Corrected detection of the updated TFWR and RFWR.
//		Fixed a bug in the model detection logic.
//		Updated the User Jumper detection logic.
// 2.10	Additional porting to the HPDI32 non-SDK Linux driver.
// 2.9	Reduced #include list in driver interface header.
//		Replaced several query options.
//		The initialization service explicitely sets the Almost Empty/Full values.
//		Fixed a bug in the Cable Command X Mode services.
//		Improved PIO and DMA pre-calculation efficientcy.
//		Linted the sources.
//		Fixed bugs in the Tx/Rx FIFO AE/AF services.
// 2.8	Updated to account for devices with updated FIFO Words Registers.
//		Added the HPDI32_QUERY_REG_FWR_UPDATE query option.
// 2.7	Updated the read_dma_available() function.
// 2.6	Corrected a system timer coun roll over bug in ioctl.c.
// 2.5	Added Single Cycle Disable support to DMDMA reads and writes.
// 2.4	Updated for the 3.x kernel.
//		Fixed value and service errors for HPDI32_IOCTL_CABLE_CMD_STATE_X.
//		Fixed a bug in the DMA capabilities determination.
//		Fixed bugs in DMA write code.
//		Fixed a bug in PIO Threshold processing for DMA and DMDMA.
//		Implemented DMDMA read support.
//		Performed code cleanup in the write service code.
// 2.3	BAR0 and BAR2 are now the only BAR regions used.
//		Include all common source, though not all are used.
// 2.2	Implemented support for the common PIO I/O routines.
//		Changed use of DEV_SUPPORTS_PROC_ID_STR macro.
//		Changed use of DEV_SUPPORTS_READ macro.
//		Changed use of DEV_SUPPORTS_WRITE macro.
//		Eliminated the global dev_check_id() routine.
// 2.1	Minor changes to the field definitions in the header file.
// 2.0	Overhauled the driver to use the GSC common code base.
//		Removed mmap interface support.
// 1.19	Updated the ISR prototype for the 2.6.19 kernel.
// 1.18	Added support for 8-bit and 16-bit I/O data samples.
// 1.17	Additional porting for newer 2.6 and 64-bit kernels.
// 1.16	Fixed a bug in that timed out DMA's reported that completed OK.
//		Mods to the PLX INTCSR are now done with restricted access.
// 1.15	Fixed a bug in the ISR - was disabling all but the serviced interrupts.
// 1.14	Modified how the I/O buffers are allocated, as well as their max size.
//		Modified cleanup code following a DMA operation.
//		Fixed a DMA timeout bug resulting in a negative timeout value.
//		Added support for the HPDI32-DIPHASE2.
//		Added a "model" field to the /proc/hpdi32 file.
//		Fixed bug in irq_gsc_acquire() - lock wasn't always released.
// 1.13	Fixed a bug in the HPDI32_IOCTL_REG_MOD service.
// 1.12	More porting to the 2.6 kernel.
// 1.11	More modularization work, plus some housekeeping updates.
// 1.10	Ported to the 2.6 kernel.
//		Modularized the sources.

// I/O services
#define	DEV_IO_STREAM_QTY					(DEV_IO_RX_STREAM_QTY + DEV_IO_TX_STREAM_QTY)
#define	DEV_IO_RX_STREAM_QTY				1
#define	DEV_IO_TX_STREAM_QTY				2

#define	DEV_IO_AUTO_START(d,i)				if ((i)->auto_start) io_auto_start((d),(i))
#define	GSC_READ_PIO_WORK
#define	GSC_WRITE_PIO_WORK

// WAIT services
#define	DEV_WAIT_GSC_ALL					HPDI32_WAIT_GSC_ALL
#define	DEV_WAIT_ALT_ALL					HPDI32_WAIT_ALT_ALL
#define	DEV_WAIT_IO_ALL						HPDI32_WAIT_IO_ALL
// Register macros.
#define	HPDI32_BCR_TX_FIFO_RESET			0x00000002
#define	HPDI32_BCR_RX_FIFO_RESET			0x00000004

#define	HPDI32_BCR_TX_ENABLE				0x00000010
#define	HPDI32_BCR_RX_ENABLE				0x00000020
#define	HPDI32_BCR_DMDMA_DIR_TX				0x00000040L

#define	HPDI32_BCR_TX_START					0x00000100
#define	HPDI32_BCR_SING_CYC_DIS				0x00000800

#define	HPDI32_BSR_TX_NOT_EMPTY				0x00000100
#define	HPDI32_BSR_TX_NOT_AE				0x00000200
#define	HPDI32_BSR_TX_NOT_AF				0x00000400
#define	HPDI32_BSR_TX_NOT_FULL				0x00000800
#define	HPDI32_BSR_RX_NOT_EMPTY				0x00001000
#define	HPDI32_BSR_RX_NOT_AE				0x00002000
#define	HPDI32_BSR_RX_NOT_AF				0x00004000
#define	HPDI32_BSR_RX_NOT_FULL				0x00008000
#define	HPDI32_BSR_TX_OVERRUN				0x00200000
#define	HPDI32_BSR_RX_UNDERRUN				0x00400000
#define	HPDI32_BSR_RX_OVERRUN				0x00800000

#define	HPDI32_FRR_CONFORMANT				0x40000000

#define	HPDI32_RAR_DECODE_EMPTY(r)			GSC_FIELD_DECODE((r),15,0)
#define	HPDI32_RAR_DECODE_FULL(r)			GSC_FIELD_DECODE((r),31,16)

#define	HPDI32_TAR_DECODE_EMPTY(r)			GSC_FIELD_DECODE((r),15,0)
#define	HPDI32_TAR_DECODE_FULL(r)			GSC_FIELD_DECODE((r),31,16)



// data types *****************************************************************

struct _dev_io_t
{
	// Initialized by open and IOCTL services (initialize and/or service specific).

	s32					auto_start;			// Auto enable Tx/Rx for reads and writes?
	s32					bmdma_threshold;	// Lower DMA transfer size limit.
	s32					data_size_bits;		// Data size in bits.
	s32					io_mode;			// PIO, BMDMA, DMDMA
	int					is_tx;				// Is this the Tx I/O structure?
	s32					overrun_check;		// Check overrun before Tx/Rx.
	s32					pio_threshold;		// Use PIO if samples <= this.
	s32					timeout_s;			// I/O timeout in seconds.
	s32					underrun_check;		// Check underrun before Tx/Rx.

	// Initialized by I/O service at time of use.

	int					abort;				// Also set via IOCTL service.
	gsc_dma_ch_t*		dma_channel;		// Use this channel for DMA.
	int					non_blocking;		// Is this non-blocking I/O?

	// Initialized by device specific I/O create code.

	int					bytes_per_sample;	// Sample size in bytes.
	u32					io_reg_offset;		// Offset of device's I/O FIFO.
	VADDR_T				io_reg_vaddr;		// Address of device's I/O FIFO.

	void				(*dev_io_sw_init)		(GSC_ALT_STRUCT_T* alt, dev_io_t* io);
	void				(*dev_io_close)			(GSC_ALT_STRUCT_T* alt, dev_io_t* io);
	void				(*dev_io_open)			(GSC_ALT_STRUCT_T* alt, dev_io_t* io);
	int					(*dev_io_startup)		(GSC_ALT_STRUCT_T* alt, dev_io_t* io);
	long				(*dev_pio_available)	(GSC_ALT_STRUCT_T* alt, dev_io_t* io, size_t count);
	long				(*dev_bmdma_available)	(GSC_ALT_STRUCT_T* alt, dev_io_t* io, size_t count);
	long				(*dev_dmdma_available)	(GSC_ALT_STRUCT_T* alt, dev_io_t* io, size_t count);
	long				(*dev_pio_xfer)			(GSC_ALT_STRUCT_T* alt, dev_io_t* io, const os_mem_t* mem, size_t count, os_time_tick_t st_end);
	long				(*dev_bmdma_xfer)		(GSC_ALT_STRUCT_T* alt, dev_io_t* io, const os_mem_t* mem, size_t count, os_time_tick_t st_end);
	long				(*dev_dmdma_xfer)		(GSC_ALT_STRUCT_T* alt, dev_io_t* io, const os_mem_t* mem, size_t count, os_time_tick_t st_end);

	struct
	{
		u32				abort;		// ...WAIT_IO_XXX_ABORT
		u32				done;		// ...WAIT_IO_XXX_DONE
		u32				error;		// ...WAIT_IO_XXX_ERROR
		u32				timeout;	// ...WAIT_IO_XXX_TIMEOUT
	} wait;

	// Initialize by GSC commone create code.

	os_mem_t			mem;				// I/O buffer.
	os_sem_t			sem;				// Only one Tx or Rx at a time.
};

struct _dev_data_t
{
	// Put an integral data type at beginning of structure.
	int					board_index;	// Index of the device being accessed.
	gsc_dev_type_t		board_type;		// Corresponds to basic device type.
	const char*			model;			// Base model number in upper case.
	int					share;			// Were we opened in shared mode?
	int					users;			// Number of currently active open() requests.
	char				proc_id_str[8];	// User Jumper setting, if supported.

	os_pci_t			pci;			// The kernel PCI device descriptor.
	os_data_t			os;				// OS specific data.
	os_spinlock_t		spinlock;		// Control ISR access.
	os_sem_t			sem;			// Control thread access.

	gsc_bar_t			bar;			// device register mappings
	gsc_dma_t			dma;			// For DMA based I/O.
	gsc_irq_t			irq;			// For interrupts.
	gsc_wait_node_t*	wait_list;

	struct
	{					// This is for streaming I/O
		dev_io_t		rx;				// For read operations.
		dev_io_t		tx;				// For write operations.
		dev_io_t*		io_streams[DEV_IO_STREAM_QTY];
	} io;

	struct
	{
		VADDR_T			plx_intcsr_32;	// Interrupt Control/Status Register
		VADDR_T			plx_dmaarb_32;	// DMA Arbitration Register
		VADDR_T			plx_dmathr_32;	// DMA Threshold Register

		VADDR_T			gsc_acr_32;		// Auxiliary Control Register
		VADDR_T			gsc_bcr_32;		// Board Control Register
		VADDR_T			gsc_bsr_32;		// Board Status Register
		VADDR_T			gsc_fdr_32;		// FIFO Data Register
		VADDR_T			gsc_frr_32;		// Firmware Revision Register
		VADDR_T			gsc_fsr_32;		// Feature Set Register
		VADDR_T			gsc_icr_32;		// Interrupt Control Register
		VADDR_T			gsc_ielr_32;	// Interrupt Edge/Level Register
		VADDR_T			gsc_ihlr_32;	// Interrupt High/Low Register
		VADDR_T			gsc_isr_32;		// Interrupt Status Register
		VADDR_T			gsc_rar_32;		// Rx Almost Register
		VADDR_T			gsc_rfsr_32;	// Rx FIFO Size Register
		VADDR_T			gsc_rfwr_32;	// Rx FIFO Words Register
		VADDR_T			gsc_rlcr_32;	// Rx Line Count Register
		VADDR_T			gsc_tar_32;		// Tx Almost Register
		VADDR_T			gsc_tfsr_32;	// Tx FIFO Size Register
		VADDR_T			gsc_tfwr_32;	// Tx FIFO Words Register

		VADDR_T			gsc_rscr_32;	// Rx Status Count Register
		VADDR_T			gsc_tcdr_32;	// Tx Clock Divider Register
		VADDR_T			gsc_tlilcr_32;	// Tx Line Invalid Line Count Register
		VADDR_T			gsc_tlvlcr_32;	// Tx Line Valid Line Count Register
		VADDR_T			gsc_tsvlcr_32;	// Tx Status Valid Line Count Register

	} vaddr;

	struct
	{
		u32				gsc_frr_32;			// 0x00	Firmware Revision Register
		u32				gsc_fsr_32;			// 0x14 Feature Set Register

		s32				bsr_d18_xcvr;		// This is a PECL/RS485 indicator or PECL differences.
		s32				bus_width;			// 64-bit or 32-bit

		s32				clock_max;			// The maximum Tx/Rx clock frequency.

		s32				dmdma_ch_1;			// Is DMDMA supported on DMA channel 1?

		s32				fifo_reset_fast;	// Are Fast FIFO Resets supported?
		u32				fifo_size_rx;		// Rx FIFO Size
		u32				fifo_size_tx;		// Tx FIFO Size
		s32				form_factor;		// PCI, PMC, ...

		s32				gpio_0_5;			// Are GPIO 0-5 supported?
		s32				gpio_6;				// Is GPIO 6 supported?
		s32				gpio_d32;			// Is the D32 GPIO feature supported?

		s32				model;				// HPDI32, HPDI32A, ...

		s32				over_under_run;		// Are the Overrun and Underrun bits supported?

		s32				reg_acr;			// Is the Auxiliary Control Register supported?
		s32				reg_fsr;			// Is the Feature Set Register supported?
		s32				reg_fwr_update;		// Updated FIFO Words Registers
		s32				reg_gir;			// Is the GPIO Input Register supported?
		s32				reg_gor;			// Is the GPIO Output Control Register supported?
		s32				reg_ielr;			// Is the Interruot Edge/Level Register supported?
		s32				reg_ihlr;			// Is the Interruot High/Low Register supported?
		s32				reg_rfsr;			// Is the Rx FIFO Size Register supported?
		s32				reg_rfwr;			// Is the Rx FIFO Words Register supported?
		s32				reg_tcdr;			// Is the Tx Clock Divider Register supported?
		s32				reg_tfsr;			// Is the Tx FIFO Size Register supported?
		s32				reg_tfwr;			// Is the Tx FIFO Words Register supported?

		s32				single_cycle_disable;// Is Single Cycle Disable supported?

		s32				tristate_te_re;		// Is the Tristate Tx/Rx Enabled feature supported?
		s32				tx_auto_stop;		// Is the Tx Auto-Start Clear control bit supported?
		s32				tx_clock_div_max;	// Maximum Tx Clock Divider value.
		s32				tx_clock_div_min;	// Minimum Tx Clock Divider value.

		s32				user_jumpers;		// Are the user jumpers supported?

		s32				xcvr_type;			// If known.

	} cache;
};



// prototypes *****************************************************************

void		dev_io_close(dev_data_t* dev);
int			dev_io_create(dev_data_t* dev);
void		dev_io_destroy(dev_data_t* dev);
int			dev_io_open(dev_data_t* dev);
dev_io_t*	dev_io_read_select(dev_data_t* dev, size_t bytes);
dev_io_t*	dev_io_write_select(dev_data_t* dev, size_t bytes);
int			dev_irq_create(dev_data_t* dev);
void		dev_irq_destroy(dev_data_t* dev);

int			dev_read_create(dev_data_t* dev, dev_io_t* io);

int			dev_write_create(dev_data_t* dev, dev_io_t* io);

int			initialize_ioctl(dev_data_t* dev, void* arg);
void		io_auto_start(dev_data_t* dev, dev_io_t* io);



#endif
