// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/driver/hpdi32.h $
// $Rev: 53399 $
// $Date: 2023-07-12 12:04:34 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Device Driver: header file

#ifndef	__HPDI32_H__
#define	__HPDI32_H__

#include "gsc_common.h"
#include "gsc_pci9080.h"
#include "gsc_pci9656.h"



// macros *********************************************************************

#define	HPDI32_BASE_NAME					"hpdi32"
#define	HPDI32_BASE_NAME_LC					HPDI32_BASE_NAME
#define	HPDI32_BASE_NAME_UC					"HPDI32"

// IOCTL command codes
#define	HPDI32_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	HPDI32_IOCTL_REG_WRITE				OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	HPDI32_IOCTL_REG_MOD				OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	HPDI32_IOCTL_QUERY					OS_IOCTL_RW( 3,  4, s32)
#define	HPDI32_IOCTL_INITIALIZE				OS_IOCTL   ( 4)

#define	HPDI32_IOCTL_CABLE_CMD_MODE_0		OS_IOCTL_RW( 5,  4, s32)	// Frame Valid/GPIO 6
#define	HPDI32_IOCTL_CABLE_CMD_MODE_1		OS_IOCTL_RW( 6,  4, s32)	// Line Valid/GPIO 0
#define	HPDI32_IOCTL_CABLE_CMD_MODE_2		OS_IOCTL_RW( 7,  4, s32)	// Status Valid/GPIO 1
#define	HPDI32_IOCTL_CABLE_CMD_MODE_3		OS_IOCTL_RW( 8,  4, s32)	// Rx Ready/GPIO 2
#define	HPDI32_IOCTL_CABLE_CMD_MODE_4		OS_IOCTL_RW( 9,  4, s32)	// Tx Ready/GPIO 3
#define	HPDI32_IOCTL_CABLE_CMD_MODE_5		OS_IOCTL_RW(10,  4, s32)	// Tx Enabled/GPIO 4
#define	HPDI32_IOCTL_CABLE_CMD_MODE_6		OS_IOCTL_RW(11,  4, s32)	// Rx Enabled/GPIO 5
#define	HPDI32_IOCTL_CABLE_CMD_STATE_0		OS_IOCTL_R (12,  4, s32)	// Frame Valid/GPIO 6
#define	HPDI32_IOCTL_CABLE_CMD_STATE_1		OS_IOCTL_R (13,  4, s32)	// Line Valid/GPIO 0
#define	HPDI32_IOCTL_CABLE_CMD_STATE_2		OS_IOCTL_R (14,  4, s32)	// Status Valid/GPIO 1
#define	HPDI32_IOCTL_CABLE_CMD_STATE_3		OS_IOCTL_R (15,  4, s32)	// Rx Ready/GPIO 2
#define	HPDI32_IOCTL_CABLE_CMD_STATE_4		OS_IOCTL_R (16,  4, s32)	// Tx Ready/GPIO 3
#define	HPDI32_IOCTL_CABLE_CMD_STATE_5		OS_IOCTL_R (17,  4, s32)	// Tx Enabled/GPIO 4
#define	HPDI32_IOCTL_CABLE_CMD_STATE_6		OS_IOCTL_R (18,  4, s32)	// Rx Enabled/GPIO 5

#define	HPDI32_IOCTL_RX_AUTO_START			OS_IOCTL_RW(19,  4, s32)
#define	HPDI32_IOCTL_RX_ENABLE				OS_IOCTL_RW(20,  4, s32)
#define	HPDI32_IOCTL_RX_LINE_COUNT			OS_IOCTL_R (21,  4, u32)
#define	HPDI32_IOCTL_RX_STATUS_COUNT		OS_IOCTL_R (22,  4, u32)

#define	HPDI32_IOCTL_RX_FIFO_AE				OS_IOCTL_RW(23,  4, s32)
#define	HPDI32_IOCTL_RX_FIFO_AF				OS_IOCTL_RW(24,  4, s32)
#define	HPDI32_IOCTL_RX_FIFO_OVERRUN		OS_IOCTL_RW(25,  4, s32)
#define	HPDI32_IOCTL_RX_FIFO_RESET			OS_IOCTL   (26)
#define	HPDI32_IOCTL_RX_FIFO_STATUS			OS_IOCTL_R (27,  4, s32)
#define	HPDI32_IOCTL_RX_FIFO_UNDERRUN		OS_IOCTL_RW(28,  4, s32)

#define	HPDI32_IOCTL_RX_IO_ABORT			OS_IOCTL_R (29,  4, s32)
#define	HPDI32_IOCTL_RX_IO_DATA_SIZE		OS_IOCTL_RW(30,  4, s32)
#define	HPDI32_IOCTL_RX_IO_MODE				OS_IOCTL_RW(31,  4, s32)
#define	HPDI32_IOCTL_RX_IO_OVERRUN			OS_IOCTL_RW(32,  4, s32)
#define	HPDI32_IOCTL_RX_IO_PIO_THRESHOLD	OS_IOCTL_RW(33,  4, s32)
#define	HPDI32_IOCTL_RX_IO_TIMEOUT			OS_IOCTL_RW(34,  4, s32)
#define	HPDI32_IOCTL_RX_IO_UNDERRUN			OS_IOCTL_RW(35,  4, s32)

#define	HPDI32_IOCTL_TX_AUTO_START			OS_IOCTL_RW(36,  4, s32)
#define	HPDI32_IOCTL_TX_AUTO_STOP			OS_IOCTL_RW(37,  4, s32)
#define	HPDI32_IOCTL_TX_CLOCK_DIVIDER		OS_IOCTL_RW(38,  4, s32)
#define	HPDI32_IOCTL_TX_ENABLE				OS_IOCTL_RW(39,  4, s32)
#define	HPDI32_IOCTL_TX_FLOW_CONTROL		OS_IOCTL_RW(40,  4, s32)
#define	HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT	OS_IOCTL_RW(41,  4, s32)
#define	HPDI32_IOCTL_TX_LINE_VAL_ON_CNT		OS_IOCTL_RW(42,  4, s32)
#define	HPDI32_IOCTL_TX_REMOTE_THROTTLE		OS_IOCTL_RW(43,  4, s32)
#define	HPDI32_IOCTL_TX_STATUS_VAL_CNT		OS_IOCTL_RW(44,  4, s32)
#define	HPDI32_IOCTL_TX_STATUS_VAL_MIR		OS_IOCTL_RW(45,  4, s32)

#define	HPDI32_IOCTL_TX_FIFO_AE				OS_IOCTL_RW(46,  4, s32)
#define	HPDI32_IOCTL_TX_FIFO_AF				OS_IOCTL_RW(47,  4, s32)
#define	HPDI32_IOCTL_TX_FIFO_OVERRUN		OS_IOCTL_RW(48,  4, s32)
#define	HPDI32_IOCTL_TX_FIFO_RESET			OS_IOCTL   (49)
#define	HPDI32_IOCTL_TX_FIFO_STATUS			OS_IOCTL_R (50,  4, s32)

#define	HPDI32_IOCTL_TX_IO_ABORT			OS_IOCTL_R (51,  4, s32)
#define	HPDI32_IOCTL_TX_IO_DATA_SIZE		OS_IOCTL_RW(52,  4, s32)
#define	HPDI32_IOCTL_TX_IO_MODE				OS_IOCTL_RW(53,  4, s32)
#define	HPDI32_IOCTL_TX_IO_PIO_THRESHOLD	OS_IOCTL_RW(54,  4, s32)
#define	HPDI32_IOCTL_TX_IO_OVERRUN			OS_IOCTL_RW(55,  4, s32)
#define	HPDI32_IOCTL_TX_IO_TIMEOUT			OS_IOCTL_RW(56,  4, s32)

#define	HPDI32_IOCTL_IRQ_CONFIG_EDGE		OS_IOCTL_RW(57,  4, s32)
#define	HPDI32_IOCTL_IRQ_CONFIG_HIGH		OS_IOCTL_RW(58,  4, s32)
#define	HPDI32_IOCTL_IRQ_ENABLE				OS_IOCTL_RW(59,  4, s32)

#define	HPDI32_IOCTL_TRISTATE_TE_RE			OS_IOCTL_RW(60,  4, s32)
#define	HPDI32_IOCTL_USER_JUMPERS			OS_IOCTL_R (61,  4, s32)

#define	HPDI32_IOCTL_WAIT_EVENT				OS_IOCTL_RW(62, 28, gsc_wait_t)
#define	HPDI32_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(63, 28, gsc_wait_t)
#define	HPDI32_IOCTL_WAIT_STATUS			OS_IOCTL_RW(64, 28, gsc_wait_t)

#define	HPDI32_IOCTL_RX_IO_BMDMA_THRESH		OS_IOCTL_RW(65,  4, s32)
#define	HPDI32_IOCTL_TX_IO_BMDMA_THRESH		OS_IOCTL_RW(66,  4, s32)

#define	HPDI32_IOCTL_GPIO_D32_OUTPUT		OS_IOCTL_RW(67,  4, s32)

//*****************************************************************************
// HPDI32_IOCTL_REG_READ
// HPDI32_IOCTL_REG_WRITE
// HPDI32_IOCTL_REG_MOD
//
#define	HPDI32_REG_ENCODE(s,o)				GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	HPDI32_GSC_FRR						HPDI32_REG_ENCODE(4,0x00)// Firmware Revision Register
#define	HPDI32_GSC_BCR						HPDI32_REG_ENCODE(4,0x04)// Board Control Register
#define	HPDI32_GSC_BSR						HPDI32_REG_ENCODE(4,0x08)// Board Status Register
#define	HPDI32_GSC_TAR						HPDI32_REG_ENCODE(4,0x0C)// Tx Almost Register
#define	HPDI32_GSC_RAR						HPDI32_REG_ENCODE(4,0x10)// Rx Almost Register
#define	HPDI32_GSC_FSR						HPDI32_REG_ENCODE(4,0x14)// Feature Set Register
#define	HPDI32_GSC_FDR						HPDI32_REG_ENCODE(4,0x18)// FIFO Data Register
#define	HPDI32_GSC_TSVLCR					HPDI32_REG_ENCODE(4,0x1C)// Tx Status Valid Length Counter Register
#define	HPDI32_GSC_TLVLCR					HPDI32_REG_ENCODE(4,0x20)// Tx Line Valid Length Counter Register
#define	HPDI32_GSC_TLILCR					HPDI32_REG_ENCODE(4,0x24)// Tx Line Invalid Length Counter Register
#define	HPDI32_GSC_RSCR						HPDI32_REG_ENCODE(4,0x28)// Rx Status Count Register
#define	HPDI32_GSC_RLCR						HPDI32_REG_ENCODE(4,0x2C)// Rx Line Count Register
#define	HPDI32_GSC_ICR						HPDI32_REG_ENCODE(4,0x30)// Interrupt Control Register
#define	HPDI32_GSC_ISR						HPDI32_REG_ENCODE(4,0x34)// Interrupt Status Register
#define	HPDI32_GSC_TCDR						HPDI32_REG_ENCODE(4,0x38)// Tx CLock Divider Register
#define	HPDI32_GSC_TFSR						HPDI32_REG_ENCODE(4,0x40)// Tx FIFO Size Register
#define	HPDI32_GSC_RFSR						HPDI32_REG_ENCODE(4,0x44)// Rx FIFO Size Register
#define	HPDI32_GSC_TFWR						HPDI32_REG_ENCODE(4,0x48)// Tx FIFO Words Register
#define	HPDI32_GSC_RFWR						HPDI32_REG_ENCODE(4,0x4C)// Rx FIFO Words Register
#define	HPDI32_GSC_IELR						HPDI32_REG_ENCODE(4,0x50)// Interrupt Edge/Level Register
#define	HPDI32_GSC_IHLR						HPDI32_REG_ENCODE(4,0x54)// Interrupt High/Low Register
#define	HPDI32_GSC_ACR						HPDI32_REG_ENCODE(4,0x60)// Auxiliary Control Register
#define	HPDI32_GSC_GOR						HPDI32_REG_ENCODE(4,0x64)// GPIO Output Register
#define	HPDI32_GSC_GIR						HPDI32_REG_ENCODE(4,0x68)// GPIO Input Register

//*****************************************************************************
// HPDI32_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	HPDI32_QUERY_BSR_D18_XCVR,		// PCI DIDR/PCI	For 32-bit PCI versions only.
	HPDI32_QUERY_BUS_WIDTH,			// PCI DIDR		32-bit or 64-bit
	HPDI32_QUERY_CLOCK_MAX,			// PCI DIDR		The maximum Tx/Rx clock frequency.
	HPDI32_QUERY_COUNT,				//				How many query options are supported?
	HPDI32_QUERY_DEVICE_TYPE,		// PCI ID regs	Value from gsc_dev_type_t
	HPDI32_QUERY_DMDMA_1,			// FSR D4		Is DMDMA supported on DMA channel 1?
	HPDI32_QUERY_FIFO_SIZE_RX,		// RFSR D0-D19	Rx FIFO depth in 32-bit samples. 0 = unknown.
	HPDI32_QUERY_FIFO_SIZE_TX,		// TFSR D0-D19	Tx FIFO depth in 32-bit samples. 0 = unknown.
	HPDI32_QUERY_FORM_FACTOR,		// FRR D24-D27	PCI, PMC, ...
	HPDI32_QUERY_GPIO_0_5,			// FSR D3		Are GPIO 0-5 supported?
	HPDI32_QUERY_GPIO_6,			// FSR D6		Is GPIO 6 supported?
	HPDI32_QUERY_MODEL,				//				HPDI32, HPDI32A, ...
	HPDI32_QUERY_OVER_UNDER_RUN,	// FSR D5		Are the Overrun and Underrun bits supported?
	HPDI32_QUERY_SINGLE_CYC_DIS,	// FSR D7		Is Single Cycle Disable supported?
	HPDI32_QUERY_TX_AUTO_STOP,		// FSR D6		Is the Tx Auto-Start Clear control bit supported?
	HPDI32_QUERY_TX_CLOCK_DIV_MAX,	// TCDR D0-D15	Maximum divider value.
	HPDI32_QUERY_TX_CLOCK_DIV_MIN,	// TCDR D0-D15	Minimum divider value.
	HPDI32_QUERY_USER_JUMPERS,		//				How many user jumpers are supported?
	HPDI32_QUERY_XCVR_TYPE,			// BSR D19		If known.
	HPDI32_QUERY_REG_FSR,			// FRR D31		Is the Feature Set Register supported?
	HPDI32_QUERY_REG_FWR_UPDATE,	// FSR D9		Has FIFO Words Regs update
	HPDI32_QUERY_REG_IELR,			// FSR D2		Is the Interruot Edge/Level Register supported?
	HPDI32_QUERY_REG_IHLR,			// FSR D2		Is the Interruot High/Low Register supported?
	HPDI32_QUERY_REG_RFSR,			// FSR D0		Is the Rx FIFO Size Register supported?
	HPDI32_QUERY_REG_RFWR,			// FSR D0		Is the Rx FIFO Size Register supported?
	HPDI32_QUERY_REG_TCDR,			// TCDR != F's	Is the Tx Clock Divider Register supported?
	HPDI32_QUERY_REG_TFSR,			// FSR D0		Is the Tx FIFO Size Register supported?
	HPDI32_QUERY_REG_TFWR,			// FSR D0		Is the Tx FIFO Size Register supported?
	HPDI32_QUERY_TRISTATE_TE_RE,	// BCR D31		Is the Tristate Tx/Rx Enabled feature supported?
	HPDI32_QUERY_GPIO_D32,			//				Is the D32 GPIO feature supported?
	HPDI32_QUERY_REG_ACR,			//				Is the Auxiliary Control Register supported?
	HPDI32_QUERY_REG_GIR,			//				Is the GPIO Input Register supported?
	HPDI32_QUERY_REG_GOR,			//				Is the GPIO Output Control Register supported?
	HPDI32_QUERY_FIFO_RESET_FAST,	//				Are Fast FIFO Resets supported?

	HPDI32_IOCTL_QUERY_LAST

} hpdi32_query_t;

#define	HPDI32_IOCTL_QUERY_ERROR			(-1)

// Options for HPDI32_QUERY_FORM_FACTOR.
#define	HPDI32_QUERY_FF_UNKNOWN				0
#define	HPDI32_QUERY_FF_PCI					1
#define	HPDI32_QUERY_FF_PMC					2
#define	HPDI32_QUERY_FF_CPCI				3
#define	HPDI32_QUERY_FF_PC104P				4

// Option HPDI32_QUERY_MODEL
#define	HPDI32_QUERY_MODEL_HPDI32			0
#define	HPDI32_QUERY_MODEL_HPDI32A			1
#define	HPDI32_QUERY_MODEL_HPDI32AL			2
#define	HPDI32_QUERY_MODEL_HPDI32ALT		3
#define	HPDI32_QUERY_MODEL_HPDI32B			4

// Options for HPDI32_QUERY_XCVR_TYPE.
#define	HPDI32_QUERY_XCVR_UNKNOWN			0
#define	HPDI32_QUERY_XCVR_PECL				1
#define	HPDI32_QUERY_XCVR_RS485				2

//*****************************************************************************
// HPDI32_IOCTL_INITIALIZE					BCR D0 (set all other fields to 0)
//
//	Parameter:	None

//*****************************************************************************
// HPDI32_IOCTL_CABLE_CMD_MODE_0			BCR D16,D24	Frame Valid/GPIO 6
// HPDI32_IOCTL_CABLE_CMD_MODE_1			BCR D17,D25	Line Valid/GPIO 0
// HPDI32_IOCTL_CABLE_CMD_MODE_2			BCR D18,D26	Status Valid/GPIO 1
// HPDI32_IOCTL_CABLE_CMD_MODE_3			BCR D19,D27	Rx Ready/GPIO 2
// HPDI32_IOCTL_CABLE_CMD_MODE_4			BCR D20,D28	Tx Ready/GPIO 3
// HPDI32_IOCTL_CABLE_CMD_MODE_5			BCR D21,D29	Tx Enabled/GPIO 4
// HPDI32_IOCTL_CABLE_CMD_MODE_6			BCR D22,D30	Rx Enabled/GPIO 5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_CABLE_CMD_MODE_FC			0x000	// Flow Control functionality
#define	HPDI32_CABLE_CMD_MODE_IN			0x100	// GPIO Input
#define	HPDI32_CABLE_CMD_MODE_OUT_LO		0x001	// GPIO Output Low
#define	HPDI32_CABLE_CMD_MODE_OUT_HI		0x101	// GPIO Output High

//*****************************************************************************
// HPDI32_IOCTL_CABLE_CMD_STATE_0			BSR D0		Frame Valid/GPIO 6
// HPDI32_IOCTL_CABLE_CMD_STATE_1			BSR D1		Line Valid/GPIO 0
// HPDI32_IOCTL_CABLE_CMD_STATE_2			BSR D2		Status Valid/GPIO 1
// HPDI32_IOCTL_CABLE_CMD_STATE_3			BSR D3		Rx Ready/GPIO 2
// HPDI32_IOCTL_CABLE_CMD_STATE_4			BSR D4		Tx Ready/GPIO 3
// HPDI32_IOCTL_CABLE_CMD_STATE_5			BSR D5		Tx Enabled/GPIO 4
// HPDI32_IOCTL_CABLE_CMD_STATE_6			BSR D6		Rx Enabled/GPIO 5
//
//	Parameter:	s32*
//		One of the following values is returned.
#define	HPDI32_CABLE_CMD_STATE_0			0
#define	HPDI32_CABLE_CMD_STATE_1			1

//*****************************************************************************
// HPDI32_IOCTL_RX_AUTO_START
// HPDI32_IOCTL_TX_AUTO_START
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_AUTO_START_NO				0
#define	HPDI32_AUTO_START_YES				1
#define	HPDI32_AUTO_START_DEFAULT			HPDI32_AUTO_START_YES

//*****************************************************************************
// HPDI32_IOCTL_RX_ENABLE					BCR D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_RX_ENABLE_NO					0
#define	HPDI32_RX_ENABLE_YES				1

//*****************************************************************************
// HPDI32_IOCTL_RX_LINE_COUNT				RLCR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range from 0 to 0xFFFFFFFF.

//*****************************************************************************
// HPDI32_IOCTL_RX_STATUS_COUNT				RSCR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range from 0 to 0xFFFFFFFF.

//*****************************************************************************
// HPDI32_IOCTL_RX_FIFO_AE					RAR D0-D15
// HPDI32_IOCTL_RX_FIFO_AF					RAR D16-D31
// HPDI32_IOCTL_TX_FIFO_AE					TAR D0-D15
// HPDI32_IOCTL_TX_FIFO_AF					TAR D16-D31
//
//	Parameter:	s32*
//		Pass in any value in the range from 0 to 0xFFFF or the FIFO size, which
//		ever is smaller. If the FIFO size is unknown then the upper limit is
//		0xFFFF. Or, pass in -1 to read the current setting.

//*****************************************************************************
// HPDI32_IOCTL_RX_FIFO_OVERRUN				BSR D23
// HPDI32_IOCTL_RX_FIFO_UNDERRUN			BSR D22
// HPDI32_IOCTL_TX_FIFO_OVERRUN				BSR D21
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	HPDI32_FIFO_ERROR_CLEAR				1
#define	HPDI32_FIFO_ERROR_TEST				(-1)

// For queries the following values are returned.
#define	HPDI32_FIFO_ERROR_NO				0
#define	HPDI32_FIFO_ERROR_YES				1

//*****************************************************************************
// HPDI32_IOCTL_RX_FIFO_RESET				BCR D2
// HPDI32_IOCTL_TX_FIFO_RESET				BCR D1
//
//	Parameter:	None

//*****************************************************************************
// HPDI32_IOCTL_RX_FIFO_STATUS				BSR D12-D15
// HPDI32_IOCTL_TX_FIFO_STATUS				BSR D8-D11
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	HPDI32_FIFO_STATUS_EMPTY			0
#define	HPDI32_FIFO_STATUS_ALMOST_EMPTY		1
#define	HPDI32_FIFO_STATUS_MEDIUM			2
#define	HPDI32_FIFO_STATUS_ALMOST_FULL		3
#define	HPDI32_FIFO_STATUS_FULL				4

//*****************************************************************************
// HPDI32_IOCTL_RX_IO_ABORT
// HPDI32_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	HPDI32_IO_ABORT_NO					0
#define	HPDI32_IO_ABORT_YES					1

//*****************************************************************************
// HPDI32_IOCTL_RX_IO_DATA_SIZE (in bits)
// HPDI32_IOCTL_TX_IO_DATA_SIZE (in bits)
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_IO_DATA_SIZE_8_BITS			8
#define	HPDI32_IO_DATA_SIZE_16_BITS			16
#define	HPDI32_IO_DATA_SIZE_32_BITS			32
#define	HPDI32_IO_DATA_SIZE_BITS_DEFAULT	HPDI32_IO_DATA_SIZE_32_BITS

//*****************************************************************************
// HPDI32_IOCTL_RX_IO_MODE
// HPDI32_IOCTL_TX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	HPDI32_IO_MODE_DEFAULT				GSC_IO_MODE_DMDMA

//*****************************************************************************
// HPDI32_IOCTL_RX_IO_OVERRUN
// HPDI32_IOCTL_RX_IO_UNDERRUN
// HPDI32_IOCTL_TX_IO_OVERRUN
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_IO_ERROR_IGNORE				0
#define	HPDI32_IO_ERROR_CHECK				1
#define	HPDI32_IO_ERROR_DEFAULT				HPDI32_IO_ERROR_CHECK

//*****************************************************************************
// HPDI32_IOCTL_RX_IO_PIO_THRESHOLD
// HPDI32_IOCTL_TX_IO_PIO_THRESHOLD
//
//	Parameter:	s32*
//		Pass in any non-negative value, or
//		-1 to read the current setting.
#define	HPDI32_IO_PIO_THRESHOLD_DEFAULT		32

//*****************************************************************************
// HPDI32_IOCTL_RX_IO_TIMEOUT (in seconds)
// HPDI32_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	HPDI32_IO_TIMEOUT_DEFAULT			10
#define	HPDI32_IO_TIMEOUT_NO_SLEEP			0
#define	HPDI32_IO_TIMEOUT_MIN				0
#define	HPDI32_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	HPDI32_IO_TIMEOUT_INFINITE			GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// HPDI32_IOCTL_TX_AUTO_STOP				BCR D6
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_AUTO_STOP_NO					1
#define	HPDI32_AUTO_STOP_YES				0

//*****************************************************************************
// HPDI32_IOCTL_TX_CLOCK_DIVIDER			TCDR D0-D15
//
//	Parameter:	s32*
//		Pass in any value in the range from 0 to 0xFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HPDI32_IOCTL_TX_ENABLE					BCR D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_TX_ENABLE_NO					0
#define	HPDI32_TX_ENABLE_YES				1

//*****************************************************************************
// HPDI32_IOCTL_TX_FLOW_CONTROL				BCR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_TX_FLOW_CONTROL_STOP			0
#define	HPDI32_TX_FLOW_CONTROL_START		1

//*****************************************************************************
// HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT			TLILCR D0-D15
//
//	Parameter:	s32*
//		Pass in any value in the range from 0 to 0xFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HPDI32_IOCTL_TX_LINE_VAL_ON_CNT			TLVLCR D0-D31
//
//	Parameter:	s32*
//		Pass in any non-negative 32-bit value, or -1 to read the current
//		setting. To apply the 32-bit value equivalent to -1 access the register
//		directly.

//*****************************************************************************
// HPDI32_IOCTL_TX_REMOTE_THROTTLE			BCR D9
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_TX_REMOTE_THROTTLE_NO		0
#define	HPDI32_TX_REMOTE_THROTTLE_YES		1

//*****************************************************************************
// HPDI32_IOCTL_TX_STATUS_VAL_CNT			TSVLCR D0-D31
//
//	Parameter:	s32*
//		Pass in any non-negative 32-bit value, or -1 to read the current
//		setting. To apply the 32-bit value equivalent to -1 access the register
//		directly.

//*****************************************************************************
// HPDI32_IOCTL_TX_STATUS_VAL_MIR			BCR D7
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_TX_STATUS_VAL_MIR_NO			0
#define	HPDI32_TX_STATUS_VAL_MIR_YES		1

//*****************************************************************************
// HPDI32_IOCTL_IRQ_CONFIG_EDGE				IELR D0-D15
// HPDI32_IOCTL_IRQ_CONFIG_HIGH				IHLR D0-D15
// HPDI32_IOCTL_IRQ_ENABLE					ICR D0-D15
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting. The value -1 cal be passed in for the
//		SEL service to determine which options are selected.
#define	HPDI32_IRQ_CC0_FV_S_GPIO6			0x00000001
#define	HPDI32_IRQ_CC0_FV_E_GPIO6			0x00000002
#define	HPDI32_IRQ_CC1_LV_GPIO0				0x00000004
#define	HPDI32_IRQ_CC2_SV_GPIO1				0x00000008
#define	HPDI32_IRQ_CC3_RR_GPIO2				0x00000010
#define	HPDI32_IRQ_CC4_TR_GPIO3				0x00000020
#define	HPDI32_IRQ_CC5_TE_GPIO4				0x00000040
#define	HPDI32_IRQ_CC6_RE_GPIO5				0x00000080
#define	HPDI32_IRQ_TX_FIFO_EMPTY			0x00000100
#define	HPDI32_IRQ_TX_FIFO_AE				0x00000200
#define	HPDI32_IRQ_TX_FIFO_AF				0x00000400
#define	HPDI32_IRQ_TX_FIFO_FULL				0x00000800
#define	HPDI32_IRQ_RX_FIFO_EMPTY			0x00001000
#define	HPDI32_IRQ_RX_FIFO_AE				0x00002000
#define	HPDI32_IRQ_RX_FIFO_AF				0x00004000
#define	HPDI32_IRQ_RX_FIFO_FULL				0x00008000
#define	HPDI32_IRQ_ALL						0x0000FFFF

//*****************************************************************************
// HPDI32_IOCTL_USER_JUMPERS				BSR D16-D17
//
//	Parameter:	s32*
//		The returned value is from 0x0 to 0x3.
//		A "1" bit indicates that the jumper is present.

//*****************************************************************************
// HPDI32_IOCTL_TRISTATE_TE_RE				BCR D31
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32_TRISTATE_TE_RE_NO			0
#define	HPDI32_TRISTATE_TE_RE_YES			1

//*****************************************************************************
// HPDI32_IOCTL_WAIT_EVENT		all fields must be valid
// HPDI32_IOCTL_WAIT_CANCEL		fields need not be valid
// HPDI32_IOCTL_WAIT_STATUS		fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	HPDI32_WAIT_GSC_CC0_FV_S_GPIO6		HPDI32_IRQ_CC0_FV_S_GPIO6
#define	HPDI32_WAIT_GSC_CC0_FV_E_GPIO6		HPDI32_IRQ_CC0_FV_E_GPIO6
#define	HPDI32_WAIT_GSC_CC1_LV_GPIO0		HPDI32_IRQ_CC1_LV_GPIO0
#define	HPDI32_WAIT_GSC_CC2_SV_GPIO1		HPDI32_IRQ_CC2_SV_GPIO1
#define	HPDI32_WAIT_GSC_CC3_RR_GPIO2		HPDI32_IRQ_CC3_RR_GPIO2
#define	HPDI32_WAIT_GSC_CC4_TR_GPIO3		HPDI32_IRQ_CC4_TR_GPIO3
#define	HPDI32_WAIT_GSC_CC5_TE_GPIO4		HPDI32_IRQ_CC5_TE_GPIO4
#define	HPDI32_WAIT_GSC_CC6_RE_GPIO5		HPDI32_IRQ_CC6_RE_GPIO5
#define	HPDI32_WAIT_GSC_TX_FIFO_EMPTY		HPDI32_IRQ_TX_FIFO_EMPTY
#define	HPDI32_WAIT_GSC_TX_FIFO_AE			HPDI32_IRQ_TX_FIFO_AE
#define	HPDI32_WAIT_GSC_TX_FIFO_AF			HPDI32_IRQ_TX_FIFO_AF
#define	HPDI32_WAIT_GSC_TX_FIFO_FULL		HPDI32_IRQ_TX_FIFO_FULL
#define	HPDI32_WAIT_GSC_RX_FIFO_EMPTY		HPDI32_IRQ_RX_FIFO_EMPTY
#define	HPDI32_WAIT_GSC_RX_FIFO_AE			HPDI32_IRQ_RX_FIFO_AE
#define	HPDI32_WAIT_GSC_RX_FIFO_AF			HPDI32_IRQ_RX_FIFO_AF
#define	HPDI32_WAIT_GSC_RX_FIFO_FULL		HPDI32_IRQ_RX_FIFO_FULL
#define	HPDI32_WAIT_GSC_ALL					HPDI32_IRQ_ALL
// gsc_wait_t.alt flags
#define	HPDI32_WAIT_ALT_ALL					0x0000
// gsc_wait_t.io
#define	HPDI32_WAIT_IO_RX_ABORT				0x0001
#define	HPDI32_WAIT_IO_RX_DONE				0x0002
#define	HPDI32_WAIT_IO_RX_ERROR				0x0004
#define	HPDI32_WAIT_IO_RX_TIMEOUT			0x0008

#define	HPDI32_WAIT_IO_TX_ABORT				0x0010
#define	HPDI32_WAIT_IO_TX_DONE				0x0020
#define	HPDI32_WAIT_IO_TX_ERROR				0x0040
#define	HPDI32_WAIT_IO_TX_TIMEOUT			0x0080

#define	HPDI32_WAIT_IO_ALL					0x00FF

//*****************************************************************************
// HPDI32_IOCTL_RX_IO_BMDMA_THRESH
// HPDI32_IOCTL_TX_IO_BMDMA_THRESH
//
//	Parameter:	s32*
//		Pass in any non-negative value from zero to the FIFO size, or
//		-1 to read the current setting.
#define	HPDI32_IO_BMDMA_THRESH_DEFAULT		132

//*****************************************************************************
// HPDI32_IOCTL_GPIO_D32_OUTPUT				ACR D0
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
//		-1 is returned if the feature is unsupported.
#define	HPDI32_GPIO_D32_OUTPUT_DISABLE		0
#define	HPDI32_GPIO_D32_OUTPUT_ENABLE		1



#endif
