// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/include/hpdi32_utils.h $
// $Rev: 53384 $
// $Date: 2023-07-12 11:13:54 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Utilities: header file

#ifndef	__HPDI32_UTILS_H__
#define	__HPDI32_UTILS_H__

#include "hpdi32_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	hpdi32_close_util			(int fd, int index, int verbose);
int hpdi32_init_util			(int verbose);
int hpdi32_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	hpdi32_open_util			(int device, int share, int index, int verbose, int* fd);
int	hpdi32_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);
int	hpdi32_write_util			(int fd, int index, int verbose, const void* src, size_t bytes, size_t* sent);

// IOCTL utility services

int	hpdi32_cable_cmd_mode_0		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_CABLE_CMD_MODE_0
int	hpdi32_cable_cmd_mode_1		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_CABLE_CMD_MODE_1
int	hpdi32_cable_cmd_mode_2		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_CABLE_CMD_MODE_2
int	hpdi32_cable_cmd_mode_3		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_CABLE_CMD_MODE_3
int	hpdi32_cable_cmd_mode_4		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_CABLE_CMD_MODE_4
int	hpdi32_cable_cmd_mode_5		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_CABLE_CMD_MODE_5
int	hpdi32_cable_cmd_mode_6		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_CABLE_CMD_MODE_6
int	hpdi32_cable_cmd_state_0	(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_CABLE_CMD_STATE_0
int	hpdi32_cable_cmd_state_1	(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_CABLE_CMD_STATE_1
int	hpdi32_cable_cmd_state_2	(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_CABLE_CMD_STATE_2
int	hpdi32_cable_cmd_state_3	(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_CABLE_CMD_STATE_3
int	hpdi32_cable_cmd_state_4	(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_CABLE_CMD_STATE_4
int	hpdi32_cable_cmd_state_5	(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_CABLE_CMD_STATE_5
int	hpdi32_cable_cmd_state_6	(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_CABLE_CMD_STATE_6

int	hpdi32_gpio_d32_output		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_GPIO_D32_OUTPUT

int	hpdi32_initialize			(int fd, int index, int verbose);								// HPDI32_IOCTL_INITIALIZE
int	hpdi32_irq_config_edge		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_IRQ_CONFIG_EDGE
int	hpdi32_irq_config_high		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_IRQ_CONFIG_HIGH
int	hpdi32_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_IRQ_ENABLE

int	hpdi32_query				(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_QUERY

int	hpdi32_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// HPDI32_IOCTL_REG_MOD
int	hpdi32_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);			// HPDI32_IOCTL_REG_READ
int	hpdi32_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// HPDI32_IOCTL_REG_WRITE
int	hpdi32_rx_auto_start		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_AUTO_START
int	hpdi32_rx_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_ENABLE
int	hpdi32_rx_fifo_ae			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_FIFO_AE
int	hpdi32_rx_fifo_af			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_FIFO_AF
int	hpdi32_rx_fifo_overrun		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_FIFO_OVERRUN
int	hpdi32_rx_fifo_reset		(int fd, int index, int verbose);								// HPDI32_IOCTL_RX_FIFO_RESET
int	hpdi32_rx_fifo_status		(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_RX_FIFO_STATUS
int	hpdi32_rx_fifo_underrun		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_FIFO_UNDERRUN
int	hpdi32_rx_io_abort			(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_RX_IO_ABORT
int	hpdi32_rx_io_bmdma_thresh	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_IO_BMDMA_THRESH
int	hpdi32_rx_io_data_size		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_IO_DATA_SIZE
int	hpdi32_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_IO_MODE
int	hpdi32_rx_io_overrun		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_IO_OVERRUN
int	hpdi32_rx_io_pio_threshold	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_IO_PIO_THRESHOLD
int	hpdi32_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_IO_TIMEOUT
int	hpdi32_rx_io_underrun		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_RX_IO_UNDERRUN
int	hpdi32_rx_line_count		(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_RX_LINE_COUNT
int	hpdi32_rx_status_count		(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_RX_STATUS_COUNT

int hpdi32_tristate_te_re		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TRISTATE_TE_RE
int	hpdi32_tx_auto_start		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_AUTO_START
int	hpdi32_tx_auto_stop			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_AUTO_STOP
int	hpdi32_tx_clock_divider		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_CLOCK_DIVIDER
int	hpdi32_tx_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_ENABLE
int	hpdi32_tx_fifo_ae			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_FIFO_AE
int	hpdi32_tx_fifo_af			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_FIFO_AF
int	hpdi32_tx_fifo_overrun		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_FIFO_OVERRUN
int	hpdi32_tx_fifo_reset		(int fd, int index, int verbose);								// HPDI32_IOCTL_TX_FIFO_RESET
int	hpdi32_tx_fifo_status		(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_TX_FIFO_STATUS
int	hpdi32_tx_flow_control		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_FLOW_CONTROL
int	hpdi32_tx_io_abort			(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_TX_IO_ABORT
int	hpdi32_tx_io_bmdma_thresh	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_IO_BMDMA_THRESH
int	hpdi32_tx_io_data_size		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_IO_DATA_SIZE
int	hpdi32_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_IO_MODE
int	hpdi32_tx_io_overrun		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_IO_OVERRUN
int	hpdi32_tx_io_pio_threshold	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_IO_PIO_THRESHOLD
int	hpdi32_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_IO_TIMEOUT
int	hpdi32_tx_line_val_off_cnt	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT
int	hpdi32_tx_line_val_on_cnt	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_LINE_VAL_ON_CNT
int	hpdi32_tx_remote_throttle	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_REMOTE_THROTTLE
int	hpdi32_tx_status_val_cnt	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_STATUS_VAL_CNT
int	hpdi32_tx_status_val_mir	(int fd, int index, int verbose, s32 set, s32* get);			// HPDI32_IOCTL_TX_STATUS_VAL_MIR

int	hpdi32_user_jumpers			(int fd, int index, int verbose, s32* get);						// HPDI32_IOCTL_USER_JUMPERS

int	hpdi32_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// HPDI32_IOCTL_WAIT_CANCEL
int	hpdi32_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// HPDI32_IOCTL_WAIT_EVENT
int	hpdi32_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// HPDI32_IOCTL_WAIT_STATUS

// Auxiliary utility services

int hpdi32_api_listing			(int fd);
int	hpdi32_config_rx			(int fd, int index, int verbose);
int	hpdi32_config_tx			(int fd, int index, int verbose);
int hpdi32_id_device			(int fd, int index, int verbose);

int	hpdi32_count_boards			(int verbose, s32* get);
int	hpdi32_reg_list				(int fd, int detail);

const gsc_reg_def_t*			hpdi32_reg_get_def_id(u32 reg);
const gsc_reg_def_t*			hpdi32_reg_get_def_index(int index);
const char*						hpdi32_reg_get_desc(u32 reg);
const char*						hpdi32_reg_get_name(u32 reg);



#endif
