// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/b2btest/cable_clock.c $
// $Rev: 48328 $
// $Date: 2020-10-23 15:47:42 -0500 (Fri, 23 Oct 2020) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _config(int fd)
{
	int	errs	= 0;

	errs	+= hpdi32_initialize		(fd, -1, 0);
	errs	+= hpdi32_tristate_te_re	(fd, -1, 0, HPDI32_TRISTATE_TE_RE_YES,	NULL);
	errs	+= hpdi32_cable_cmd_mode_0	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_IN,	NULL);	// Frame Valid/GPIO 6
	errs	+= hpdi32_cable_cmd_mode_1	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_IN,	NULL);	// Line Valid/GPIO 0
	errs	+= hpdi32_cable_cmd_mode_2	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_IN,	NULL);	// Status Valid/GPIO 1
	errs	+= hpdi32_cable_cmd_mode_3	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_IN,	NULL);	// Rx Ready/GPIO 2
	errs	+= hpdi32_cable_cmd_mode_4	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_IN,	NULL);	// Tx Ready/GPIO 3
	errs	+= hpdi32_cable_cmd_mode_5	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_IN,	NULL);	// Tx Enabled/GPIO 4
	errs	+= hpdi32_cable_cmd_mode_6	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_IN,	NULL);	// Rx Enabled/GPIO 5
	return(errs);
}



//*****************************************************************************
static int _rx_fifo_test(int fd)
{
	u32	after	= 0;
	u32	before	= 0;
	int	errs	= 0;

	os_sleep_ms(10);
	errs	+= hpdi32_rx_fifo_reset	(fd, -1, 0);
	os_sleep_ms(10);
	errs	+= hpdi32_reg_read		(fd, -1, 0, HPDI32_GSC_RFWR, &before);
	os_sleep_ms(10);
	errs	+= hpdi32_reg_read		(fd, -1, 0, HPDI32_GSC_RFWR, &after);

	if (before == 0)
		errs++;

	if (after <= before)
		errs++;

	return(errs);
}



//*****************************************************************************
int cable_clock_test(int fd_tx, int fd_rx)
{
	int	errs	= 0;
	int	i;

	gsc_label("Cable Clock");

	for (i = 0; (errs == 0) && (i < 10); i++)
	{
		errs	+= _config(fd_tx);
		errs	+= _config(fd_rx);

		errs	+= hpdi32_tx_clock_divider	(fd_tx, -1, 0, 10, NULL);
		errs	+= hpdi32_tx_enable			(fd_tx, -1, 0, HPDI32_TX_ENABLE_YES, NULL);
		errs	+= hpdi32_rx_enable			(fd_rx, -1, 0, HPDI32_RX_ENABLE_YES, NULL);

		errs	+= _rx_fifo_test(fd_rx);

		errs	+= hpdi32_initialize(fd_tx, -1, 0);
		errs	+= hpdi32_initialize(fd_rx, -1, 0);
	}

	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}


