// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/id/perform.c $
// $Rev: 53391 $
// $Date: 2023-07-12 11:19:44 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _id_device_frr(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) hpdi32_reg_get_def_id(HPDI32_GSC_FRR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, hpdi32_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. hpdi32_reg_get_def_id, HPDI32_GSC_FRR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _id_device_fsr(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= (gsc_reg_def_t*) hpdi32_reg_get_def_id(HPDI32_GSC_FSR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, hpdi32_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. hpdi32_reg_get_def_id, HPDI32_GSC_FSR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= hpdi32_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	for (i = 0; i < HPDI32_IOCTL_QUERY_LAST; i++)
		errs	+= hpdi32_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_frr(args);
	errs	+= _id_device_fsr(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


