// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/irq/frame_valid_end.c $
// $Rev: 46889 $
// $Date: 2020-02-24 15:24:58 -0600 (Mon, 24 Feb 2020) $

// HPDI32: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	return(STATUS_SUPPORTED);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	char	buf[100]	= "";
	int		errs		= 0;
	int		ret;

	errs	+= hpdi32_initialize			(fd, -1, 0);
	errs	+= hpdi32_tx_io_mode			(fd, -1, 0, GSC_IO_MODE_PIO,			NULL);
	errs	+= hpdi32_tx_io_pio_threshold	(fd, -1, 0, 0,							NULL);
	errs	+= hpdi32_tx_enable				(fd, -1, 0, HPDI32_TX_ENABLE_YES,		NULL);
	errs	+= hpdi32_tx_auto_start			(fd, -1, 0, HPDI32_AUTO_START_YES,		NULL);
	errs	+= hpdi32_irq_enable			(fd, -1, 0, HPDI32_IRQ_CC0_FV_E_GPIO6,	NULL);

	ret		= hpdi32_write(fd, buf, sizeof(buf));

	if (ret != sizeof(buf))
	{
		errs++;
		//printf("ERROR: hpdi32_write() failure\n");
	}

	os_sleep_ms(10);
	return(errs);
}



//*****************************************************************************
int frame_valid_end_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


