// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/irq/gpio_6.c $
// $Rev: 46889 $
// $Date: 2020-02-24 15:24:58 -0600 (Mon, 24 Feb 2020) $

// HPDI32: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	int	errs;
	s32	gpio;
	int	ret;

	errs	= hpdi32_query(fd, -1, 0, HPDI32_QUERY_GPIO_6, &gpio);

	if (errs)
		ret	= errs;
	else
		ret	= gpio ? STATUS_SUPPORTED : STATUS_NOT_SUPPORTED;

	return(ret);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	int	errs	= 0;

	errs	+= hpdi32_initialize		(fd, -1, 0);
	errs	+= hpdi32_cable_cmd_mode_0	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_OUT_LO,	NULL);
	errs	+= hpdi32_irq_enable		(fd, -1, 0, HPDI32_WAIT_GSC_CC0_FV_S_GPIO6,	NULL);
	errs	+= hpdi32_cable_cmd_mode_0	(fd, -1, 0, HPDI32_CABLE_CMD_MODE_OUT_HI,	NULL);

	return(errs);
}



//*****************************************************************************
int gpio_6_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


