// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/irq/main.h $
// $Rev: 53393 $
// $Date: 2023-07-12 11:23:05 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdlib.h>
#include <time.h>

#include "hpdi32_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	STATUS_NOT_IMPLEMENTED	(-2)
#define	STATUS_NOT_SUPPORTED	(-1)
#define	STATUS_SUPPORTED		(0)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int	frame_valid_end_irq_test(int fd, int supported);
int	frame_valid_start_irq_test(int fd, int supported);

int	gpio_0_irq_test(int fd, int supported);
int	gpio_1_irq_test(int fd, int supported);
int	gpio_2_irq_test(int fd, int supported);
int	gpio_3_irq_test(int fd, int supported);
int	gpio_4_irq_test(int fd, int supported);
int	gpio_5_irq_test(int fd, int supported);
int	gpio_6_irq_test(int fd, int supported);

int	line_valid_irq_test(int fd, int supported);

int	main_gsc_irq_test(int fd, int supported);
int	main_dma_irq_test(int fd, int supported);
int	main_pci_irq_test(int fd, int supported);

int	perform_tests(const args_t* args);

int	rx_enabled_irq_test(int fd, int supported);
int	rx_fifo_ae_irq_test(int fd, int supported);
int	rx_fifo_af_irq_test(int fd, int supported);
int	rx_fifo_empty_irq_test(int fd, int supported);
int	rx_fifo_full_irq_test(int fd, int supported);
int	rx_ready_irq_test(int fd, int supported);

int	status_valid_irq_test(int fd, int supported);

int	tx_enabled_irq_test(int fd, int supported);
int	tx_fifo_ae_irq_test(int fd, int supported);
int	tx_fifo_af_irq_test(int fd, int supported);
int	tx_fifo_empty_irq_test(int fd, int supported);
int	tx_fifo_full_irq_test(int fd, int supported);
int	tx_ready_irq_test(int fd, int supported);



#endif
