// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/irq/main_pci.c $
// $Rev: 46889 $
// $Date: 2020-02-24 15:24:58 -0600 (Mon, 24 Feb 2020) $

// HPDI32: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	return(STATUS_SUPPORTED);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	char	buf[100]	= "";
	int		cycles;
	int		errs		= 0;
	int		ret;

	// An issue we face with PCI interrupt detection is that the driver
	// receives PCI interrupts which are generated by other devices due to
	// interrupt sharing. Therefore, we need to keep generating PCI interrupts
	// until we detect that the waiting thread has finished.

	for (cycles = 0; (errs == 0) && (cycles < 1000); cycles++)
	{
		errs	+= hpdi32_initialize			(fd, -1, 0);
		errs	+= hpdi32_tx_io_mode			(fd, -1, 0, GSC_IO_MODE_PIO,			NULL);
		errs	+= hpdi32_tx_io_pio_threshold	(fd, -1, 0, 0,							NULL);
		errs	+= hpdi32_tx_enable				(fd, -1, 0, HPDI32_TX_ENABLE_YES,		NULL);
		errs	+= hpdi32_tx_auto_start			(fd, -1, 0, HPDI32_AUTO_START_YES,		NULL);
		errs	+= hpdi32_irq_enable			(fd, -1, 0, HPDI32_IRQ_CC1_LV_GPIO0,	NULL);

		ret		= hpdi32_write(fd, buf, sizeof(buf));

		if (ret != sizeof(buf))
		{
			errs++;
			//printf("ERROR: hpdi32_write() failure\n");
		}
	}

	return(errs);
}



//*****************************************************************************
int main_pci_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


