// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/irq/status_valid.c $
// $Rev: 46889 $
// $Date: 2020-02-24 15:24:58 -0600 (Mon, 24 Feb 2020) $

// HPDI32: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	int	errs;
	s32	model;
	int	ret;

	errs	= hpdi32_query(fd, -1, 0, HPDI32_QUERY_MODEL, &model);

	if (errs)
		ret	= errs;
	else if (model == HPDI32_QUERY_MODEL_HPDI32AL)
		ret	= STATUS_NOT_SUPPORTED;
	else if (model == HPDI32_QUERY_MODEL_HPDI32ALT)
		ret	= STATUS_NOT_SUPPORTED;
	else
		ret	= STATUS_SUPPORTED;

	return(ret);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	char	buf[100]	= "";
	int		errs		= 0;
	int		ret;

	errs	+= hpdi32_initialize			(fd, -1, 0);
	errs	+= hpdi32_tx_io_mode			(fd, -1, 0, GSC_IO_MODE_PIO,				NULL);
	errs	+= hpdi32_tx_io_pio_threshold	(fd, -1, 0, 0,								NULL);
	errs	+= hpdi32_tx_enable				(fd, -1, 0, HPDI32_TX_ENABLE_YES,			NULL);
	errs	+= hpdi32_tx_auto_start			(fd, -1, 0, HPDI32_AUTO_START_YES,			NULL);
	errs	+= hpdi32_irq_enable			(fd, -1, 0, HPDI32_IRQ_CC2_SV_GPIO1,		NULL);
	errs	+= hpdi32_tx_status_val_cnt		(fd, -1, 0, 10,								NULL);
	errs	+= hpdi32_tx_status_val_mir		(fd, -1, 0, HPDI32_TX_STATUS_VAL_MIR_YES,	NULL);

	ret		= hpdi32_write(fd, buf, sizeof(buf));

	if (ret != sizeof(buf))
	{
		errs++;
		//printf("ERROR: hpdi32_write() failure\n");
	}

	return(errs);
}



//*****************************************************************************
int status_valid_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


