// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/irq/tx_fifo_empty.c $
// $Rev: 53393 $
// $Date: 2023-07-12 11:23:05 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	return(STATUS_SUPPORTED);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	u32		buf[100]	= { 0 };
	int		errs		= 0;
	size_t	sent;

	errs	+= hpdi32_initialize	(fd, -1, 0);
	errs	+= hpdi32_tx_io_mode	(fd, -1, 0, GSC_IO_MODE_PIO,			NULL);
	errs	+= hpdi32_tx_auto_start	(fd, -1, 0, HPDI32_AUTO_START_NO,		NULL);
	errs	+= hpdi32_irq_enable	(fd, -1, 0, HPDI32_IRQ_TX_FIFO_EMPTY,	NULL);

	errs	+= hpdi32_write_util(fd, -1, 0, buf, sizeof(buf), &sent);

	if (sent != sizeof(buf))
	{
		errs++;
		//printf("ERROR: hpdi32_write() failure\n");
	}

	os_sleep_ms(1);

	errs	+= hpdi32_tx_fifo_reset(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
int tx_fifo_empty_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


