// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/cable_cmd_mode_3.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_CABLE_CMD_MODE_3,
			/* arg		*/	HPDI32_CABLE_CMD_MODE_FC,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x08080000,
			/* value	*/	0x00000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_CABLE_CMD_MODE_3,
			/* arg		*/	HPDI32_CABLE_CMD_MODE_OUT_LO,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x08080000,
			/* value	*/	0x00080000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_CABLE_CMD_MODE_3,
			/* arg		*/	HPDI32_CABLE_CMD_MODE_IN,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x08080000,
			/* value	*/	0x08000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_CABLE_CMD_MODE_3,
			/* arg		*/	HPDI32_CABLE_CMD_MODE_OUT_HI,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x08080000,
			/* value	*/	0x08080000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= hpdi32_initialize(fd, -1, 0);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= hpdi32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_CABLE_CMD_MODE_3,
			/* arg		*/	HPDI32_CABLE_CMD_MODE_OUT_LO,
			/* reg		*/	HPDI32_GSC_BSR,
			/* mask		*/	0x08,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_CABLE_CMD_MODE_3,
			/* arg		*/	HPDI32_CABLE_CMD_MODE_OUT_HI,
			/* reg		*/	HPDI32_GSC_BSR,
			/* mask		*/	0x08,
			/* value	*/	0x08
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= hpdi32_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_get_list(fd, list);

	errs	+= service_ioctl_set_get_list(fd, list);

	errs	+= hpdi32_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	cable_cmd_mode_3_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_CABLE_CMD_MODE_3.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int cable_cmd_mode_3_test(int fd)
{
	int	errs;
	s32	gpio;

	gsc_label("HPDI32_IOCTL_CABLE_CMD_MODE_3");
	errs	= hpdi32_query(fd, -1, 0, HPDI32_QUERY_GPIO_0_5, &gpio);

	if (errs)
	{
	}
	else if (gpio == 0)
	{
		printf("SKIPPED  (Not supported on this device.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


