// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/main.h $
// $Rev: 53397 $
// $Date: 2023-07-12 11:59:33 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "hpdi32_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing
	s32	verbose;

	int	fd;				// File descriptor for the device to access.

	// Device Settings

} args_t;

typedef enum
{
	SERVICE_END_LIST,	// Ends list of service_data_t structures.
	SERVICE_NONE,		// Do nothing.
	SERVICE_NORMAL,
	SERVICE_REG_MOD,
	SERVICE_REG_READ,
	SERVICE_REG_SHOW,
	SERVICE_REG_TEST,
	SERVICE_REG_WRITE,	// arg = # of times to write
	SERVICE_SLEEP,		// arg = # of seconds to sleep
	SERVICE_SLEEP_MS,	// arg = # of milliseconds to sleep
	SERVICE_IOCTL_GET,
	SERVICE_IOCTL_SET
} service_t;

typedef struct
{
	service_t		service;
	unsigned long	cmd;	// IOCTL code
	s32				arg;	// The IOCTL data argument.
	u32				reg;	// The register to access. Use -1 to ignore.
	u32				mask;	// The register bits of interest.
	u32				value;	// The value expected for the bits of interest.
} service_data_t;



// prototypes *****************************************************************

int	cable_cmd_mode_0_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_MODE_0
int	cable_cmd_mode_1_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_MODE_1
int	cable_cmd_mode_2_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_MODE_2
int	cable_cmd_mode_3_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_MODE_3
int	cable_cmd_mode_4_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_MODE_4
int	cable_cmd_mode_5_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_MODE_5
int	cable_cmd_mode_6_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_MODE_6
int	cable_cmd_state_0_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_STATE_0
int	cable_cmd_state_1_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_STATE_1
int	cable_cmd_state_2_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_STATE_2
int	cable_cmd_state_3_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_STATE_3
int	cable_cmd_state_4_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_STATE_4
int	cable_cmd_state_5_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_STATE_5
int	cable_cmd_state_6_test(int fd);			// HPDI32_IOCTL_CABLE_CMD_STATE_6
int	cable_command_0_test(int fd, int verbose);
int	cable_command_1_test(int fd, int verbose);
int	cable_command_2_test(int fd, int verbose);
int	cable_command_3_test(int fd, int verbose);
int	cable_command_4_test(int fd, int verbose);
int	cable_command_5_test(int fd, int verbose);
int	cable_command_6_test(int fd, int verbose);
int	clock_test(int fd, int verbose);

int	initialize_test(int fd);				// HPDI32_IOCTL_INITIALIZE
int	irq_config_edge_test(int fd);			// HPDI32_IOCTL_IRQ_CONFIG_EDGE
int	irq_config_high_test(int fd);			// HPDI32_IOCTL_IRQ_CONFIG_HIGH
int	irq_enable_test(int fd);				// HPDI32_IOCTL_IRQ_ENABLE

int	perform_tests(const args_t* args);

int	query_test(int fd);						// HPDI32_IOCTL_QUERY

int	reg_mod_test(int fd);					// HPDI32_IOCTL_REG_MOD
int	reg_read_test(int fd);					// HPDI32_IOCTL_REG_READ
int	reg_write_test(int fd);					// HPDI32_IOCTL_REG_WRITE

int	rx_auto_start_test(int fd);				// HPDI32_IOCTL_RX_AUTO_START
int	rx_enable_test(int fd);					// HPDI32_IOCTL_RX_ENABLE
int	rx_fifo_ae_test(int fd);				// HPDI32_IOCTL_RX_FIFO_AE
int	rx_fifo_af_test(int fd);				// HPDI32_IOCTL_RX_FIFO_AF
int	rx_fifo_overrun_test(int fd);			// HPDI32_IOCTL_RX_FIFO_OVERRUN
int	rx_fifo_reset_test(int fd);				// HPDI32_IOCTL_RX_FIFO_RESET
int	rx_fifo_status_test(int fd);			// HPDI32_IOCTL_RX_FIFO_STATUS
int	rx_fifo_underrun_test(int fd);			// HPDI32_IOCTL_RX_FIFO_UNDERRUN
int	rx_io_abort_test(int fd);				// HPDI32_IOCTL_RX_IO_ABORT
int	rx_io_bmdma_thresh_test(int fd);		// HPDI32_IOCTL_RX_IO_BMDMA_THRESH
int	rx_io_data_size_test(int fd);			// HPDI32_IOCTL_RX_IO_DATA_SIZE
int	rx_io_mode_test(int fd);				// HPDI32_IOCTL_RX_IO_MODE
int	rx_io_overrun_test(int fd);				// HPDI32_IOCTL_RX_IO_OVERRUN
int	rx_io_pio_threshold_test(int fd);		// HPDI32_IOCTL_RX_IO_PIO_THRESHOLD
int	rx_io_timeout_test(int fd);				// HPDI32_IOCTL_RX_IO_TIMEOUT
int	rx_io_underrun_test(int fd);			// HPDI32_IOCTL_RX_IO_UNDERRUN
int	rx_line_count_test(int fd);				// HPDI32_IOCTL_RX_LINE_COUNT
int	rx_status_count_test(int fd);			// HPDI32_IOCTL_RX_STATUS_COUNT

int	service_ioctl_reg_get_list(int fd, const service_data_t* list);
int	service_ioctl_set_list(int fd, const service_data_t* list);
int	service_ioctl_set_get_list(int fd, const service_data_t* list);
int	service_ioctl_set_reg_list(int fd, const service_data_t* list);

int	tristate_te_re_test(int fd);			// HPDI32_IOCTL_TRISTATE_TE_RE
int	tx_auto_start_test(int fd);				// HPDI32_IOCTL_TX_AUTO_START
int	tx_auto_stop_test(int fd);				// HPDI32_IOCTL_TX_AUTO_STOP
int	tx_clock_divider_test(int fd);			// HPDI32_IOCTL_TX_CLOCK_DIVIDER
int	tx_enable_test(int fd);					// HPDI32_IOCTL_TX_ENABLE
int	tx_fifo_ae_test(int fd);				// HPDI32_IOCTL_TX_FIFO_AE
int	tx_fifo_af_test(int fd);				// HPDI32_IOCTL_TX_FIFO_AF
int	tx_fifo_overrun_test(int fd);			// HPDI32_IOCTL_TX_FIFO_OVERRUN
int	tx_fifo_reset_test(int fd);				// HPDI32_IOCTL_TX_FIFO_RESET
int	tx_fifo_status_test(int fd);			// HPDI32_IOCTL_TX_FIFO_STATUS
int	tx_flow_control_test(int fd);			// HPDI32_IOCTL_TX_FLOW_CONTROL
int	tx_io_abort_test(int fd);				// HPDI32_IOCTL_TX_IO_ABORT
int	tx_io_bmdma_thresh_test(int fd);		// HPDI32_IOCTL_TX_IO_BMDMA_THRESH
int	tx_io_data_size_test(int fd);			// HPDI32_IOCTL_TX_IO_DATA_SIZE
int	tx_io_mode_test(int fd);				// HPDI32_IOCTL_TX_IO_MODE
int	tx_io_overrun_test(int fd);				// HPDI32_IOCTL_TX_IO_OVERRUN
int	tx_io_pio_threshold_test(int fd);		// HPDI32_IOCTL_TX_IO_PIO_THRESHOLD
int	tx_io_timeout_test(int fd);				// HPDI32_IOCTL_TX_IO_TIMEOUT
int	tx_line_val_off_cnt_test(int fd);		// HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT
int	tx_line_val_on_cnt_test(int fd);		// HPDI32_IOCTL_TX_LINE_VAL_ON_CNT
int	tx_remote_throttle_test(int fd);		// HPDI32_IOCTL_TX_REMOTE_THROTTLE
int	tx_status_val_cnt_test(int fd);			// HPDI32_IOCTL_TX_STATUS_VAL_CNT
int	tx_status_val_mir_test(int fd);			// HPDI32_IOCTL_TX_STATUS_VAL_MIR

int	user_jumpers_test(int fd);				// HPDI32_IOCTL_USER_JUMPERS

int	wait_cancel_test(int fd);				// HPDI32_IOCTL_WAIT_CANCEL
int	wait_event_test(int fd);				// HPDI32_IOCTL_WAIT_EVENT
int	wait_status_test(int fd);				// HPDI32_IOCTL_WAIT_STATUS



#endif
