// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/perform.c $
// $Rev: 52308 $
// $Date: 2022-12-20 15:44:14 -0600 (Tue, 20 Dec 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= reg_read_test(args->fd);				// HPDI32_IOCTL_REG_READ
	errs	+= reg_write_test(args->fd);			// HPDI32_IOCTL_REG_WRITE
	errs	+= reg_mod_test(args->fd);				// HPDI32_IOCTL_REG_MOD
	errs	+= query_test(args->fd);				// HPDI32_IOCTL_QUERY
	errs	+= initialize_test(args->fd);			// HPDI32_IOCTL_INITIALIZE

	errs	+= cable_cmd_mode_0_test(args->fd);		// HPDI32_IOCTL_CABLE_CMD_MODE_0
	errs	+= cable_cmd_mode_1_test(args->fd);		// HPDI32_IOCTL_CABLE_CMD_MODE_1
	errs	+= cable_cmd_mode_2_test(args->fd);		// HPDI32_IOCTL_CABLE_CMD_MODE_2
	errs	+= cable_cmd_mode_3_test(args->fd);		// HPDI32_IOCTL_CABLE_CMD_MODE_3
	errs	+= cable_cmd_mode_4_test(args->fd);		// HPDI32_IOCTL_CABLE_CMD_MODE_4
	errs	+= cable_cmd_mode_5_test(args->fd);		// HPDI32_IOCTL_CABLE_CMD_MODE_5
	errs	+= cable_cmd_mode_6_test(args->fd);		// HPDI32_IOCTL_CABLE_CMD_MODE_6
	errs	+= cable_cmd_state_0_test(args->fd);	// HPDI32_IOCTL_CABLE_CMD_STATE_0
	errs	+= cable_cmd_state_1_test(args->fd);	// HPDI32_IOCTL_CABLE_CMD_STATE_1
	errs	+= cable_cmd_state_2_test(args->fd);	// HPDI32_IOCTL_CABLE_CMD_STATE_2
	errs	+= cable_cmd_state_3_test(args->fd);	// HPDI32_IOCTL_CABLE_CMD_STATE_3
	errs	+= cable_cmd_state_4_test(args->fd);	// HPDI32_IOCTL_CABLE_CMD_STATE_4
	errs	+= cable_cmd_state_5_test(args->fd);	// HPDI32_IOCTL_CABLE_CMD_STATE_5
	errs	+= cable_cmd_state_6_test(args->fd);	// HPDI32_IOCTL_CABLE_CMD_STATE_6

	errs	+= rx_auto_start_test(args->fd);		// HPDI32_IOCTL_RX_AUTO_START
	errs	+= rx_enable_test(args->fd);			// HPDI32_IOCTL_RX_ENABLE
	errs	+= rx_line_count_test(args->fd);		// HPDI32_IOCTL_RX_LINE_COUNT
	errs	+= rx_status_count_test(args->fd);		// HPDI32_IOCTL_RX_STATUS_COUNT
	errs	+= rx_fifo_ae_test(args->fd);			// HPDI32_IOCTL_RX_FIFO_AE
	errs	+= rx_fifo_af_test(args->fd);			// HPDI32_IOCTL_RX_FIFO_AF
	errs	+= rx_fifo_overrun_test(args->fd);		// HPDI32_IOCTL_RX_FIFO_OVERRUN
	errs	+= rx_fifo_reset_test(args->fd);		// HPDI32_IOCTL_RX_FIFO_RESET
	errs	+= rx_fifo_status_test(args->fd);		// HPDI32_IOCTL_RX_FIFO_STATUS
	errs	+= rx_fifo_underrun_test(args->fd);		// HPDI32_IOCTL_RX_FIFO_UNDERRUN
	errs	+= rx_io_abort_test(args->fd);			// HPDI32_IOCTL_RX_IO_ABORT
	errs	+= rx_io_bmdma_thresh_test(args->fd);	// HPDI32_IOCTL_RX_IO_BMDMA_THRESH
	errs	+= rx_io_data_size_test(args->fd);		// HPDI32_IOCTL_RX_IO_DATA_SIZE
	errs	+= rx_io_mode_test(args->fd);			// HPDI32_IOCTL_RX_IO_MODE
	errs	+= rx_io_overrun_test(args->fd);		// HPDI32_IOCTL_RX_IO_OVERRUN
	errs	+= rx_io_pio_threshold_test(args->fd);	// HPDI32_IOCTL_RX_IO_PIO_THRESHOLD
	errs	+= rx_io_timeout_test(args->fd);		// HPDI32_IOCTL_RX_IO_TIMEOUT
	errs	+= rx_io_underrun_test(args->fd);		// HPDI32_IOCTL_RX_IO_UNDERRUN

	errs	+= tx_auto_start_test(args->fd);		// HPDI32_IOCTL_TX_AUTO_START
	errs	+= tx_auto_stop_test(args->fd);			// HPDI32_IOCTL_TX_AUTO_STOP
	errs	+= tx_clock_divider_test(args->fd);		// HPDI32_IOCTL_TX_CLOCK_DIVIDER
	errs	+= tx_enable_test(args->fd);			// HPDI32_IOCTL_TX_ENABLE
	errs	+= tx_flow_control_test(args->fd);		// HPDI32_IOCTL_TX_FLOW_CONTROL
	errs	+= tx_line_val_off_cnt_test(args->fd);	// HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT
	errs	+= tx_line_val_on_cnt_test(args->fd);	// HPDI32_IOCTL_TX_LINE_VAL_ON_CNT
	errs	+= tx_remote_throttle_test(args->fd);	// HPDI32_IOCTL_TX_REMOTE_THROTTLE
	errs	+= tx_status_val_cnt_test(args->fd);	// HPDI32_IOCTL_TX_STATUS_VAL_CNT
	errs	+= tx_status_val_mir_test(args->fd);	// HPDI32_IOCTL_TX_STATUS_VAL_MIR
	errs	+= tx_fifo_ae_test(args->fd);			// HPDI32_IOCTL_TX_FIFO_AE
	errs	+= tx_fifo_af_test(args->fd);			// HPDI32_IOCTL_TX_FIFO_AF
	errs	+= tx_fifo_overrun_test(args->fd);		// HPDI32_IOCTL_TX_FIFO_OVERRUN
	errs	+= tx_fifo_reset_test(args->fd);		// HPDI32_IOCTL_TX_FIFO_RESET
	errs	+= tx_fifo_status_test(args->fd);		// HPDI32_IOCTL_TX_FIFO_STATUS
	errs	+= tx_io_abort_test(args->fd);			// HPDI32_IOCTL_TX_IO_ABORT
	errs	+= tx_io_bmdma_thresh_test(args->fd);	// HPDI32_IOCTL_TX_IO_BMDMA_THRESH
	errs	+= tx_io_data_size_test(args->fd);		// HPDI32_IOCTL_TX_IO_DATA_SIZE
	errs	+= tx_io_mode_test(args->fd);			// HPDI32_IOCTL_TX_IO_MODE
	errs	+= tx_io_pio_threshold_test(args->fd);	// HPDI32_IOCTL_TX_IO_PIO_THRESHOLD
	errs	+= tx_io_overrun_test(args->fd);		// HPDI32_IOCTL_TX_IO_OVERRUN
	errs	+= tx_io_timeout_test(args->fd);		// HPDI32_IOCTL_TX_IO_TIMEOUT

	errs	+= irq_config_edge_test(args->fd);		// HPDI32_IOCTL_IRQ_CONFIG_EDGE
	errs	+= irq_config_high_test(args->fd);		// HPDI32_IOCTL_IRQ_CONFIG_HIGH
	errs	+= irq_enable_test(args->fd);			// HPDI32_IOCTL_IRQ_ENABLE

	errs	+= tristate_te_re_test(args->fd);		// HPDI32_IOCTL_TRISTATE_TE_RE
	errs	+= user_jumpers_test(args->fd);			// HPDI32_IOCTL_USER_JUMPERS
	errs	+= wait_event_test(args->fd);			// HPDI32_IOCTL_WAIT_EVENT
	errs	+= wait_cancel_test(args->fd);			// HPDI32_IOCTL_WAIT_CANCEL
	errs	+= wait_status_test(args->fd);			// HPDI32_IOCTL_WAIT_STATUS

	errs	+= clock_test(args->fd, args->verbose);
	errs	+= cable_command_0_test(args->fd, args->verbose);
	errs	+= cable_command_1_test(args->fd, args->verbose);
	errs	+= cable_command_2_test(args->fd, args->verbose);
	errs	+= cable_command_3_test(args->fd, args->verbose);
	errs	+= cable_command_4_test(args->fd, args->verbose);
	errs	+= cable_command_5_test(args->fd, args->verbose);
	errs	+= cable_command_6_test(args->fd, args->verbose);

	return(errs);
}


