// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/query.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(void)
{
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	s32	data;
	s32	count;
	int	err;
	int	errs;
	int	i;

	errs	= hpdi32_query(fd, -1, 0, HPDI32_QUERY_COUNT, &count);

	if (errs)
	{
		errs	= 1;
		printf("FAIL <---  (hpdi32_query(..., COUNT) error)\n");
	}
	else if (count != (HPDI32_IOCTL_QUERY_LAST))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) HPDI32_IOCTL_QUERY_LAST,
				(long) count);
	}
	else
	{
		for (i = 0; i < HPDI32_IOCTL_QUERY_LAST; i++)
		{
			err		= hpdi32_query(fd, -1, 0, i, &data);
			errs	+= err ? 1 : 0;
		}

		if (errs)
		{
			printf(	"FAIL <---  (%d query error%s)\n",
					errs,
					(errs == 1) ? "" : "s");
		}
	}

	return(errs);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("HPDI32_IOCTL_QUERY");

	errs	+= _service_test();
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


