// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/tristate_te_re.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TRISTATE_TE_RE,
			/* arg		*/	HPDI32_TRISTATE_TE_RE_NO,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x80000000,
			/* value	*/	0x00000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TRISTATE_TE_RE,
			/* arg		*/	HPDI32_TRISTATE_TE_RE_YES,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x80000000,
			/* value	*/	0x80000000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= hpdi32_initialize(fd, -1, 0);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= hpdi32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	// This required additional equipment to verity.
	return(0);
}



/******************************************************************************
*
*	Function:	tristate_te_re_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_TRISTATE_TE_RE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tristate_te_re_test(int fd)
{
	int	errs;
	s32	get		= 0;

	gsc_label("HPDI32_IOCTL_TRISTATE_TE_RE");
	errs	= hpdi32_query(fd, -1, 0, HPDI32_QUERY_TRISTATE_TE_RE, &get);

	if (errs)
	{
	}
	else if (get == 0)
	{
		printf("SKIPPED  (Not supported on this device.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test();

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


