// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/tx_fifo_status.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	u32	bsr;
	int	errs	= 0;
	int	ret;
	s32	status;

	errs	+= hpdi32_initialize(fd, -1, 0);
	ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_TX_FIFO_STATUS, &status);
	errs	+= ret ? 1 : 0;
	errs	+= hpdi32_reg_read(fd, -1, 0, HPDI32_GSC_BSR, &bsr);

	if (errs)
	{
	}
	else if (status != HPDI32_FIFO_STATUS_EMPTY)
	{
		errs++;
		printf(	"ERROR <---  (Got status %ld, expected %ld.)\n",
				(long) status,
				(long) HPDI32_FIFO_STATUS_EMPTY);
	}
	else if ((bsr & 0xF00) != 0xC00)
	{
		errs++;
		printf(	"ERROR <---  (Tx FIFO is not empty; got 0x%lX, expect %lX.)\n",
				(long) bsr & 0xF00,
				(long) 0xC00);
	}

	errs	+= hpdi32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	// We don't perform device tests due to 64-bit AF/AE variances.
	return(0);
}



/******************************************************************************
*
*	Function:	tx_fifo_status_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_TX_FIFO_STATUS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tx_fifo_status_test(int fd)
{
	int	errs	= 0;

	gsc_label("HPDI32_IOCTL_TX_FIFO_STATUS");
	errs	+= _service_test(fd);
	errs	+= _function_test();

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


