// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/tx_io_data_size.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_8_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_16_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_32_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= hpdi32_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= hpdi32_initialize(fd, -1, 0);

	return(errs);
}



//*****************************************************************************
static int _8_bit_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_MODE,
			/* arg		*/	GSC_IO_MODE_PIO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_IO_MODE,
			/* arg		*/	GSC_IO_MODE_PIO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_CLOCK_DIVIDER,
			/* arg		*/	512,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_ENABLE,
			/* arg		*/	HPDI32_TX_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_ENABLE,
			/* arg		*/	HPDI32_RX_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_8_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_8_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_2[]	=
	{
		{				//	Tx Strart
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x100,
			/* value	*/	0x100
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	10,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HPDI32_GSC_RLCR,
			/* mask		*/	0xFFFFFFFF,
			/* value	*/	10
		},

		{ SERVICE_END_LIST }
	};

	u8	buf[10];
	int	errs	= 0;
	int	i;
	int	j;
	u8	val;

	for (i = 0; i <= 9; i++)
		buf[i]	= '0' + i;

	errs	+= hpdi32_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_list(fd, list_1);
	hpdi32_write(fd, buf, 10);
	errs	+= service_ioctl_set_list(fd, list_2);

	if (errs == 0)
	{
		memset(buf, 0, sizeof(buf));
		hpdi32_read(fd, buf, 10);
	};

	if (errs == 0)
	{
		for (i = 0; i <= 9; i++)
		{
			val	= '0' + i;

			if (val != buf[i])
			{
				errs++;
				printf("FAIL <---  (%d. 8-bit data mismatch)\n", __LINE__);

				for (j = 0; j <= 9; j++)
					printf(" %02lX", (long) buf[j]);

				printf("\n");
				break;
			}
		}
	}

	errs	+= hpdi32_initialize(fd, -1, 0);

	return(errs);
}



//*****************************************************************************
static int _16_bit_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_MODE,
			/* arg		*/	GSC_IO_MODE_PIO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_IO_MODE,
			/* arg		*/	GSC_IO_MODE_PIO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_CLOCK_DIVIDER,
			/* arg		*/	512,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_ENABLE,
			/* arg		*/	HPDI32_TX_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_ENABLE,
			/* arg		*/	HPDI32_RX_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_16_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_16_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_2[]	=
	{
		{				//	Tx Strart
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x100,
			/* value	*/	0x100
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	10,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HPDI32_GSC_RLCR,
			/* mask		*/	0xFFFFFFFF,
			/* value	*/	10
		},

		{ SERVICE_END_LIST }
	};

	u16	buf[10];
	int	errs	= 0;
	int	i;
	int	j;
	u16	val;

	for (i = 0; i <= 9; i++)
	{
		buf[i]	= '0' + i;
		buf[i]	= buf[i] | (buf[i] << 8);
	}

	errs	+= hpdi32_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_list(fd, list_1);
	hpdi32_write(fd, buf, 20);
	errs	+= service_ioctl_set_list(fd, list_2);

	if (errs == 0)
	{
		memset(buf, 0, sizeof(buf));
		hpdi32_read(fd, buf, 20);
	};

	if (errs == 0)
	{
		for (i = 0; i <= 9; i++)
		{
			val	= '0' + i;
			val	= val | (val << 8);

			if (val != buf[i])
			{
				errs++;
				printf("FAIL <---  (%d. 16-bit data mismatch)\n", __LINE__);

				for (j = 0; j <= 9; j++)
					printf(" %04lX", (long) buf[j]);

				printf("\n");
				break;
			}
		}
	}

	errs	+= hpdi32_initialize(fd, -1, 0);

	return(errs);
}



//*****************************************************************************
static int _32_bit_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_MODE,
			/* arg		*/	GSC_IO_MODE_PIO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_IO_MODE,
			/* arg		*/	GSC_IO_MODE_PIO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_CLOCK_DIVIDER,
			/* arg		*/	512,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_ENABLE,
			/* arg		*/	HPDI32_TX_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_ENABLE,
			/* arg		*/	HPDI32_RX_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_32_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_RX_IO_DATA_SIZE,
			/* arg		*/	HPDI32_IO_DATA_SIZE_32_BITS,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_2[]	=
	{
		{				//	Tx Strart
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x100,
			/* value	*/	0x100
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	10,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HPDI32_GSC_RLCR,
			/* mask		*/	0xFFFFFFFF,
			/* value	*/	10
		},

		{ SERVICE_END_LIST }
	};

	u32	buf[10];
	int	errs	= 0;
	int	i;
	int	j;
	u32	val;

	for (i = 0; i <= 9; i++)
	{
		buf[i]	= '0' + i;
		buf[i]	= buf[i] | (buf[i] << 8);
		buf[i]	= buf[i] | (buf[i] << 16);
	}

	errs	+= hpdi32_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_list(fd, list_1);
	hpdi32_write(fd, buf, 40);
	errs	+= service_ioctl_set_list(fd, list_2);

	if (errs == 0)
	{
		memset(buf, 0, sizeof(buf));
		hpdi32_read(fd, buf, 40);
	};

	if (errs == 0)
	{
		for (i = 0; i <= 9; i++)
		{
			val	= '0' + i;
			val	= val | (val << 8);
			val	= val | (val << 16);

			if (val != buf[i])
			{
				errs++;
				printf("FAIL <---  (%d. 32-bit data mismatch)\n", __LINE__);

				for (j = 0; j <= 9; j++)
					printf(" %08lX", (long) buf[j]);

				printf("\n");
				break;
			}
		}
	}

	errs	+= hpdi32_initialize(fd, -1, 0);

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	errs	+= _8_bit_test(fd);
	errs	+= _16_bit_test(fd);
	errs	+= _32_bit_test(fd);

	return(errs);
}



/******************************************************************************
*
*	Function:	tx_io_data_size_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_TX_IO_DATA_SIZE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tx_io_data_size_test(int fd)
{
	int	errs	= 0;

	gsc_label("HPDI32_IOCTL_TX_IO_DATA_SIZE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


