// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/tx_io_pio_threshold.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_IO_PIO_THRESHOLD,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;
	int	i;

	for (i = 0; i <= 30; i++)
	{
		// Walking one.
		list[0].arg		= 1L << i;

		errs	+= hpdi32_initialize(fd, -1, 0);
		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= hpdi32_initialize(fd, -1, 0);

		// Walking zero.
		list[0].arg		= 0x7FFFFFFF ^ (1L << i);

		errs	+= hpdi32_initialize(fd, -1, 0);
		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= service_ioctl_set_get_list(fd, list);
		errs	+= hpdi32_initialize(fd, -1, 0);
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	return(0);
}



/******************************************************************************
*
*	Function:	tx_io_pio_threshold_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_TX_IO_PIO_THRESHOLD.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tx_io_pio_threshold_test(int fd)
{
	int	errs	= 0;

	gsc_label("HPDI32_IOCTL_TX_IO_PIO_THRESHOLD");
	errs	+= _service_test(fd);
	errs	+= _function_test();

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


