// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/tx_line_val_off_cnt.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT,
			/* arg		*/	0,
			/* reg		*/	HPDI32_GSC_TLILCR,
			/* mask		*/	0xFFFF,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;
	int	i;

	for (i = 0; i <= 15; i++)
	{
		// Walking one.
		list[0].arg		= 1 << i;
		list[0].value	= 1 << i;

		errs	+= hpdi32_initialize(fd, -1, 0);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= hpdi32_initialize(fd, -1, 0);

		// Walking zero.
		list[0].arg		= 0xFFFF ^ (1 << i);
		list[0].value	= 0xFFFF ^ (1 << i);

		errs	+= hpdi32_initialize(fd, -1, 0);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= hpdi32_initialize(fd, -1, 0);
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	// Not tested due to differences between the models.
	// 32-bit devices function as documented.
	// 64-bit devices have no leading Line Invalid period.
	return(0);
}



/******************************************************************************
*
*	Function:	tx_line_val_off_cnt_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tx_line_val_off_cnt_test(int fd)
{
	int	errs	= 0;

	gsc_label("HPDI32_IOCTL_TX_LINE_VAL_OFF_CNT");
	errs	+= _service_test(fd);
	errs	+= _function_test();

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


