// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/tx_status_val_mir.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_STATUS_VAL_MIR,
			/* arg		*/	HPDI32_TX_STATUS_VAL_MIR_NO,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x80,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HPDI32_IOCTL_TX_STATUS_VAL_MIR,
			/* arg		*/	HPDI32_TX_STATUS_VAL_MIR_YES,
			/* reg		*/	HPDI32_GSC_BCR,
			/* mask		*/	0x80,
			/* value	*/	0x80
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	// User manuals have ths feature documented the inverse of its operation.
	errs	+= hpdi32_initialize(fd, -1, 0);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= hpdi32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	// Not tested due to differences between the models.
	// 32-bit devices function as documented.
	// 64-bit devices have no leading Line Invalid period.
	// 64-bit devices do not have a functional Status Valid implemented.
	return(0);
}



/******************************************************************************
*
*	Function:	tx_status_val_mir_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_TX_STATUS_VAL_MIR.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tx_status_val_mir_test(int fd)
{
	int	errs	= 0;

	gsc_label("HPDI32_IOCTL_TX_STATUS_VAL_MIR");
	errs	+= _service_test(fd);
	errs	+= _function_test();

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


