// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/sbtest/user_jumpers.c $
// $Rev: 51590 $
// $Date: 2022-10-05 07:04:06 -0500 (Wed, 05 Oct 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	u32	bsr;
	int	errs	= 0;
	int	ret;
	s32	setting;
	s32	status;

	errs	+= hpdi32_initialize(fd, -1, 0);
	ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_USER_JUMPERS, &status);
	errs	+= ret ? 1 : 0;
	errs	+= hpdi32_reg_read(fd, -1, 0, HPDI32_GSC_BSR, &bsr);
	setting	= (bsr & 0x30000) >> 16;

	if (errs)
	{
	}
	else if (status != setting)
	{
		errs++;
		printf(	"ERROR <---  (Got 0x%lX, expected 0x%lX.)\n",
				(long) status,
				(long) setting);
	}

	errs	+= hpdi32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	// This cannot be verified by software.
	return(0);
}



/******************************************************************************
*
*	Function:	user_jumpers_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HPDI32_IOCTL_USER_JUMPERS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int user_jumpers_test(int fd)
{
	int	errs;
	s32	jump;

	gsc_label("HPDI32_IOCTL_USER_JUMPERS");
	errs	= hpdi32_query(fd, -1, 0, HPDI32_QUERY_USER_JUMPERS, &jump);

	if (errs)
	{
	}
	else if (jump == 0)
	{
		printf("SKIPPED  (Not supported on this device.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test();

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


