// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/signals/gpio.c $
// $Rev: 52307 $
// $Date: 2022-12-20 15:43:52 -0600 (Tue, 20 Dec 2022) $

// HPDI32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _gpio_0(const args_t* args, int supported, int period)
{
	s32	arg;
	int	errs	= 0;
	int	ret;

	if (supported == 0)
	{
	}
	else if (period == 0)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_HI;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_1, &arg);
		errs	+= ret ? 1 : 0;
	}
	else if (period == 7)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_LO;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_1, &arg);
		errs	+= ret ? 1 : 0;
	}

	return(errs);
}



//*****************************************************************************
static int _gpio_1(const args_t* args, int supported, int period)
{
	s32	arg;
	int	errs	= 0;
	int	ret;

	if (supported == 0)
	{
	}
	else if (period >= 2)
	{
	}
	else if (period % 2)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_LO;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_2, &arg);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_HI;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_2, &arg);
		errs	+= ret ? 1 : 0;
	}

	return(errs);
}



//*****************************************************************************
static int _gpio_2(const args_t* args, int supported, int period)
{
	s32	arg;
	int	errs	= 0;
	int	ret;

	if (supported == 0)
	{
	}
	else if (period >= 4)
	{
	}
	else if (period % 2)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_LO;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_3, &arg);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_HI;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_3, &arg);
		errs	+= ret ? 1 : 0;
	}

	return(errs);
}



//*****************************************************************************
static int _gpio_3(const args_t* args, int supported, int period)
{
	s32	arg;
	int	errs	= 0;
	int	ret;

	if (supported == 0)
	{
	}
	else if (period >= 6)
	{
	}
	else if (period % 2)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_LO;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_4, &arg);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_HI;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_4, &arg);
		errs	+= ret ? 1 : 0;
	}

	return(errs);
}



//*****************************************************************************
static int _gpio_4(const args_t* args, int supported, int period)
{
	s32	arg;
	int	errs	= 0;
	int	ret;

	if (supported == 0)
	{
	}
	else if (period >= 8)
	{
	}
	else if (period % 2)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_LO;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_5, &arg);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_HI;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_5, &arg);
		errs	+= ret ? 1 : 0;
	}

	return(errs);
}



//*****************************************************************************
static int _gpio_5(const args_t* args, int supported, int period)
{
	s32	arg;
	int	errs	= 0;
	int	ret;

	if (supported == 0)
	{
	}
	else if (period >= 10)
	{
	}
	else if (period % 2)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_LO;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_6, &arg);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_HI;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_6, &arg);
		errs	+= ret ? 1 : 0;
	}

	return(errs);
}



//*****************************************************************************
static int _gpio_6(const args_t* args, int supported, int period)
{
	s32	arg;
	int	errs	= 0;
	int	ret;

	if (supported == 0)
	{
	}
	else if (period >= 12)
	{
	}
	else if (period % 2)
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_LO;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_0, &arg);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		arg		= HPDI32_CABLE_CMD_MODE_OUT_HI;
		ret		= hpdi32_ioctl(args->fd, HPDI32_IOCTL_CABLE_CMD_MODE_0, &arg);
		errs	+= ret ? 1 : 0;
	}

	return(errs);
}



//*****************************************************************************
static int _signals(const args_t* args, int _0_5, int _6)
{
	int		cycle;
	int		errs	= 0;
	int		period;

	for (cycle = 0; cycle < 600; cycle++)
	{
		for (period = 0; period < 14; period++)
		{
			_gpio_0(args, _0_5, period);
			_gpio_1(args, _0_5, period);
			_gpio_2(args, _0_5, period);
			_gpio_3(args, _0_5, period);
			_gpio_4(args, _0_5, period);
			_gpio_5(args, _0_5, period);
			_gpio_6(args, _6,	period);

			os_sleep_ms(2);
		}
	}

	return(errs);
}



//*****************************************************************************
int gpio_signals(const args_t* args)
{
	s32	_0_5;
	s32	_6;
	int		errs	= 0;

	gsc_label("GPIO Signals");

	errs	+= hpdi32_query(args->fd, -1, 0, HPDI32_QUERY_GPIO_0_5, &_0_5);
	errs	+= hpdi32_query(args->fd, -1, 0, HPDI32_QUERY_GPIO_6, &_6);

	if (errs)
	{
	}
	else if ((_0_5 == 0) && (_6 == 0))
	{
		printf("SKIPPED  (Not supported on this device.)\n");
	}
	else
	{
		printf("\n");
		gsc_label_level_inc();

		if ((_0_5) && (_6))
			gsc_label("GPIO 0-6");
		else if (_0_5)
			gsc_label("GPIO 0-5");
		else
			gsc_label("GPIO 6");

		errs	+= _signals(args, _0_5, _6);

		if (errs == 0)
			printf("Done\n");

		gsc_label_level_dec();
	}

	return(errs);
}


