// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/txrate/main.h $
// $Rev: 53395 $
// $Date: 2023-07-12 11:57:23 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "hpdi32_main.h"



// macros *********************************************************************

#define	SCAN_ALMOST_EMPTY_SIZE	0x1
#define	SCAN_ALMOST_FULL_SIZE	0x2
#define	SCAN_WRITE_SIZE			0x4

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	clock_div;		// Clock Divider
	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	scan;
	s32	seconds;		// Tx data for this number of seconds.
	s32	test_limit;		// for continuous testing
	s32	tx_mb;
	s32	tx_stats;

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	io_mode;
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
