// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/echo.c $
// $Rev: 43022 $
// $Date: 2018-06-22 17:36:23 -0500 (Fri, 22 Jun 2018) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

const command_entry_t			cmd_echo	=
{
	/* cmd		*/	"echo",
	/* desc		*/	"Echo a string as output to the display.",
	/* function	*/	_callback,
	/* arg_qty	*/	0,
	/* arg_list	*/	NULL
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	char	buf[1024];
	int		errs	= 0;
	char*	psz;

	if (line_data)
	{
		config_display_verbose(fd, line_data, &cmd_echo, 0);
		psz	= (char*) strchr((char*) line_data->line_buf, '=');

		if (psz)
		{
			psz	= skip_ws(psz + 1);
			strncpy(buf, psz, sizeof(buf));
			buf[sizeof(buf) - 1]	= 0;
			trunk_ws(buf);
		}
		else
		{
			buf[0]	= 0;
		}

		printf("%s\n", buf);
	}
	else
	{
		// Print the current value.
		// No current value to print.
	}

	return(errs);
}


