// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/reg_show.c $
// $Rev: 43022 $
// $Date: 2018-06-22 17:36:23 -0500 (Fri, 22 Jun 2018) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

static const arg_entry_t		_arg_1	=
{
	/* type	*/	ARG_TYPE_STR_S32,
	/* qty	*/	SIZEOF_ARRAY(firmware_arg_set),
	/* list	*/	(void*) firmware_arg_set
};

static const arg_entry_t*		_arg_list[]	=
{
	&_arg_1
};

const command_entry_t			cmd_reg_show	=
{
	/* cmd		*/	"reg_show",
	/* desc		*/	"Read a register and display the value read.",
	/* function	*/	_callback,
	/* arg_qty	*/	SIZEOF_ARRAY(_arg_list),
	/* arg_list	*/	_arg_list
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	gsc_reg_t	arg;
	int			errs	= 0;
	s32			reg		= 0;
	int			ret;

	if (line_data)
	{
		memset(&arg, 0, sizeof(arg));
		errs	= config_arg_qty_verify(line_data, 2);	// cmd = reg

		if (errs == 0)
			errs	= config_arg_validate_str_s32(line_data, 1, &cmd_reg_show, &reg);

		if (errs == 0)
		{
			arg.reg		= reg;
			arg.value	= 0xDEADBEEF;
			arg.mask	= 0;
			ret			= hpdi32_ioctl(fd, HPDI32_IOCTL_REG_READ, &arg);
			errs		+= ret ? 1 : 0;
		}

		if (errs == 0)
		{
			gsc_label_suffix(line_data->text[0], " ");
			printf("= %s ; 0x%08lX\n", line_data->text[1], (long) arg.value);
		}
	}
	else
	{
		// Print the current value.
		// We don't print current register contents.
	}

	return(errs);
}


