// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/rx_fifo_underrun.c $
// $Rev: 43022 $
// $Date: 2018-06-22 17:36:23 -0500 (Fri, 22 Jun 2018) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

static const arg_type_str_s32_t	_arg_1_set[]	=
{
	// name		value						desc
	{ "clear",	HPDI32_FIFO_ERROR_CLEAR,	"Clear an Rx FIFO Underrun, if there is one."	},
	{ "test",	HPDI32_FIFO_ERROR_TEST,		"Check to see if there is an Rx FIFO Underrun."	},
	{ "-1",		HPDI32_FIFO_ERROR_TEST,		"Check to see if there is an Rx FIFO Underrun."	},
};

static const arg_entry_t		_arg_1	=
{
	/* type	*/	ARG_TYPE_STR_S32,
	/* qty	*/	SIZEOF_ARRAY(_arg_1_set),
	/* list	*/	(void*) _arg_1_set
};

static const arg_entry_t*		_arg_list[]	=
{
	&_arg_1
};

const command_entry_t		cmd_rx_fifo_underrun	=
{
	/* cmd		*/	"rx_fifo_underrun",
	/* desc		*/	"Check for an Rx FIFO Underrun.",
	/* function	*/	_callback,
	/* arg_qty	*/	SIZEOF_ARRAY(_arg_list),
	/* arg_list	*/	_arg_list
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	int	errs	= 0;
	int	ret;
	s32	set		= 0;
	s32	tmp		= 0;

	if (line_data)
	{
		errs	= config_arg_qty_verify(line_data, 2);	// cmd = arg

		if (errs == 0)
			errs	= config_arg_validate_str_s32(line_data, 1, &cmd_rx_fifo_underrun, &set);

		if (errs == 0)
		{
			tmp		= set;
			ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_RX_FIFO_UNDERRUN, &set);
			errs	+= ret ? 1 : 0;
		}

		if (errs == 0)
			config_display_verbose(fd, line_data, &cmd_rx_fifo_underrun, tmp);
	}
	else
	{
		// Print the current value.
		set		= -1;
		ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_RX_FIFO_UNDERRUN, &set);
		errs	+= ret ? 1 : 0;

		if (errs == 0)
		{
			switch (set)
			{
				default:

					errs	= 1;
					printf("INTERNAL ERROR: line %d, file %s\n", __LINE__, __FILE__);
					break;

				case HPDI32_FIFO_ERROR_NO:

					printf("no");
					break;

				case HPDI32_FIFO_ERROR_YES:

					printf("yes");
					break;
			}
		}
	}

	return(errs);
}


