// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/rx_status_count.c $
// $Rev: 43022 $
// $Date: 2018-06-22 17:36:23 -0500 (Fri, 22 Jun 2018) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

const command_entry_t			cmd_rx_status_count	=
{
	/* cmd		*/	"rx_status_count",
	/* desc		*/	"Report the Rx Status Count.",
	/* function	*/	_callback,
	/* arg_qty	*/	0,
	/* arg_list	*/	NULL
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	int	errs	= 0;
	int	ret;
	s32	set;

	if (line_data)
	{
		errs	= config_arg_qty_none_verify(line_data);	// "cmd" or "cmd ="

		if (errs == 0)
			config_display_verbose(fd, line_data, &cmd_rx_status_count, -1);
	}
	else
	{
		// Print the current value.
		set		= -1;
		ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_RX_STATUS_COUNT, &set);
		errs	+= ret ? 1 : 0;

		if (errs == 0)
			printf("%ld  (0x%lX)", (long) set, (long) set);
	}

	return(errs);
}


