// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/sleep_ms.c $
// $Rev: 46631 $
// $Date: 2019-12-17 14:39:14 -0600 (Tue, 17 Dec 2019) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

static const arg_type_s32_range_t	_arg_1_set[]	=
{
	// min	max		desc
	{ 1,	10000,	"Sleep for this number of milliseconds."	},
};

static const arg_entry_t		_arg_1	=
{
	/* type	*/	ARG_TYPE_S32_RANGE,
	/* qty	*/	SIZEOF_ARRAY(_arg_1_set),
	/* list	*/	(void*) _arg_1_set
};

static const arg_entry_t*		_arg_list[]	=
{
	&_arg_1
};

const command_entry_t			cmd_sleep_ms	=
{
	/* cmd		*/	"sleep_ms",
	/* desc		*/	"Sleep for a specified number of milliseconds..",
	/* function	*/	_callback,
	/* arg_qty	*/	SIZEOF_ARRAY(_arg_list),
	/* arg_list	*/	_arg_list
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	int	errs	= 0;
	s32	set		= 0;

	if (line_data)
	{
		errs	= config_arg_qty_verify(line_data, 2);	// cmd = arg

		if (errs == 0)
			errs	= config_arg_validate_s32_range(line_data, 1, &cmd_sleep_ms, &set);

		if (errs == 0)
		{
			config_display_verbose(fd, line_data, &cmd_sleep_ms, 0);
			os_sleep_ms(set);
		}
	}
	else
	{
		// Print the current value.
		// There is no value to print.
	}

	return(errs);
}


