// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/time_us.c $
// $Rev: 46631 $
// $Date: 2019-12-17 14:39:14 -0600 (Tue, 17 Dec 2019) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

const command_entry_t			cmd_time_us	=
{
	/* cmd		*/	"time_us",
	/* desc		*/	"Report the current time with us resolution.",
	/* function	*/	_callback,
	/* arg_qty	*/	0,
	/* arg_list	*/	NULL
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	int				errs	= 0;
	os_time_us_t	tv;

	if (line_data)
	{
		errs	= config_arg_qty_none_verify(line_data);	// "cmd" or "cmd ="

		if (errs == 0)
			config_display_verbose(fd, line_data, &cmd_time_us, -1);
	}
	else
	{
		// Print the current value.
		os_time_get_us(&tv);
		tv.tv_sec	-= global.tv.tv_sec;
		printf("%ld.%06ld", (long) tv.tv_sec, (long) tv.tv_usec);
	}

	return(errs);
}


