// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/tx_fifo_status.c $
// $Rev: 43022 $
// $Date: 2018-06-22 17:36:23 -0500 (Fri, 22 Jun 2018) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

const command_entry_t		cmd_tx_fifo_status	=
{
	/* cmd		*/	"tx_fifo_status",
	/* desc		*/	"Report the Tx FIFO fill status.",
	/* function	*/	_callback,
	/* arg_qty	*/	0,
	/* arg_list	*/	NULL
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	int	errs	= 0;
	int	ret;
	s32	set;

	if (line_data)
	{
		errs	= config_arg_qty_none_verify(line_data);	// "cmd" or "cmd ="

		if (errs == 0)
			config_display_verbose(fd, line_data, &cmd_tx_fifo_status, -1);
	}
	else
	{
		// Print the current value.
		ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_TX_FIFO_STATUS, &set);
		errs	+= ret ? 1 : 0;

		if (errs == 0)
		{
			switch (set)
			{
				default:

					errs	= 1;
					printf("INTERNAL ERROR: line %d, file %s\n", __LINE__, __FILE__);
					break;

				case HPDI32_FIFO_STATUS_EMPTY:

					printf("empty");
					break;

				case HPDI32_FIFO_STATUS_ALMOST_EMPTY:

					printf("almost empty");
					break;

				case HPDI32_FIFO_STATUS_MEDIUM:

					printf("medium");
					break;

				case HPDI32_FIFO_STATUS_ALMOST_FULL:

					printf("almost Full");
					break;

				case HPDI32_FIFO_STATUS_FULL:

					printf("full");
					break;
			}
		}
	}

	return(errs);
}


