// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/verbose.c $
// $Rev: 43022 $
// $Date: 2018-06-22 17:36:23 -0500 (Fri, 22 Jun 2018) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

static const arg_type_str_s32_t	_arg_1_set[]	=
{
	// name		value	desc
	{ "no",		0,		"Work quietly."					},
	{ "yes",	1,		"Work verbosely."				},
	{ "-1",		-1,		"Query the current setting."	}
};

static const arg_entry_t		_arg_1	=
{
	/* type	*/	ARG_TYPE_STR_S32,
	/* qty	*/	SIZEOF_ARRAY(_arg_1_set),
	/* list	*/	(void*) _arg_1_set
};

static const arg_entry_t*		_arg_list[]	=
{
	&_arg_1
};

const command_entry_t			cmd_verbose	=
{
	/* cmd		*/	"verbose",
	/* desc		*/	"Control how verbosely processing is performed.",
	/* function	*/	_callback,
	/* arg_qty	*/	SIZEOF_ARRAY(_arg_list),
	/* arg_list	*/	_arg_list
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	int	errs	= 0;
	s32	set		= 0;

	if (line_data)
	{
		errs	= config_arg_qty_verify(line_data, 2);	// cmd = arg

		if (errs == 0)
			errs	= config_arg_validate_str_s32(line_data, 1, &cmd_verbose, &set);

		if (errs == 0)
		{
			if (set >= 0)
				global.verbose	= set;

			config_display_verbose(fd, line_data, &cmd_verbose, set);
		}
	}
	else
	{
		// Print the current value.
		errs	= config_val_str_s32_print(
					global.verbose,
					SIZEOF_ARRAY(_arg_1_set),
					_arg_1_set);
	}

	return(errs);
}


