// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/samples/xfer/write_src_file.c $
// $Rev: 43022 $
// $Date: 2018-06-22 17:36:23 -0500 (Fri, 22 Jun 2018) $

// HPDI32: Sample Application: source file

#include "main.h"



// prototypes *****************************************************************

static int _callback(int fd, line_data_t* line_data);



// variables ******************************************************************

static const arg_type_str_s32_t	_arg_1_set[]	=
{
	// name		value	desc
	{ "name",	0,		"Write the data from this file."	},
	{ "-1",		-1,		"Query the current setting."		}
};

static const arg_entry_t		_arg_1	=
{
	/* type	*/	ARG_TYPE_STR_S32,
	/* qty	*/	SIZEOF_ARRAY(_arg_1_set),
	/* list	*/	(void*) _arg_1_set
};

static const arg_entry_t*		_arg_list[]	=
{
	&_arg_1
};

const command_entry_t			cmd_write_src_file	=
{
	/* cmd		*/	"write_src_file",
	/* desc		*/	"When transmitting data from a file, use this file.",
	/* function	*/	_callback,
	/* arg_qty	*/	SIZEOF_ARRAY(_arg_list),
	/* arg_list	*/	_arg_list
};



//*****************************************************************************
static int _callback(int fd, line_data_t* line_data)
{
	int	errs	= 0;

	if (line_data)
	{
		errs	= config_arg_qty_verify(line_data, 2);	// cmd = arg

		if (errs)
		{
			// Do nothing.
		}
		else if (strcmp(line_data->text[1], "-1") == 0)
		{
			config_display_verbose(fd, line_data, &cmd_write_src_file, -1);
		}
		else
		{
			config_display_verbose(fd, line_data, &cmd_write_src_file, 0);
			strncpy(global.write_src_file, line_data->text[1], sizeof(global.write_src_file));
			global.write_src_file[sizeof(global.write_src_file) - 1]	= 0;
		}

		// We do nothing with the file selection at this point.
		// That is handled at the time of the "write" operation.
	}
	else
	{
		// Print the current value.
		printf("%s", global.write_src_file);
	}

	return(errs);
}


