// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/utils/util_config_rx.c $
// $Rev: 53382 $
// $Date: 2023-07-12 11:12:16 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Utilities: source file

#include "main.h"



//*****************************************************************************
int hpdi32_config_rx(int fd, int index, int verbose)
{
	int	errs	= 0;

	if (verbose)
	{
		gsc_label_index("Receiver Configuration", index);
		printf("\n");
		gsc_label_level_inc();
	}

	errs	+= hpdi32_initialize			(fd, -1, verbose);

	// Settings must be applied after the initialization call!

	errs	+= hpdi32_rx_io_bmdma_thresh	(fd, -1, verbose, HPDI32_IO_BMDMA_THRESH_DEFAULT,	NULL);
	errs	+= hpdi32_rx_io_data_size		(fd, -1, verbose, HPDI32_IO_DATA_SIZE_32_BITS,		NULL);
	errs	+= hpdi32_rx_io_mode			(fd, -1, verbose, GSC_IO_MODE_BMDMA,				NULL);
	errs	+= hpdi32_rx_io_pio_threshold	(fd, -1, verbose, HPDI32_IO_PIO_THRESHOLD_DEFAULT,	NULL);
	errs	+= hpdi32_rx_io_overrun			(fd, -1, verbose, HPDI32_IO_ERROR_CHECK,			NULL);
	errs	+= hpdi32_rx_io_timeout			(fd, -1, verbose, HPDI32_IO_TIMEOUT_DEFAULT,		NULL);
	errs	+= hpdi32_rx_io_underrun		(fd, -1, verbose, HPDI32_IO_ERROR_CHECK,			NULL);

	errs	+= hpdi32_tristate_te_re		(fd, -1, verbose, HPDI32_TRISTATE_TE_RE_NO,			NULL);
	errs	+= hpdi32_cable_cmd_mode_0		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Frame Valid (output)
	errs	+= hpdi32_cable_cmd_mode_1		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Line Valid (output)
	errs	+= hpdi32_cable_cmd_mode_2		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Status Valid (output)
	errs	+= hpdi32_cable_cmd_mode_3		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Rx Ready (Input, Remote Throttling)
	errs	+= hpdi32_cable_cmd_mode_4		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Tx Ready (output)
	errs	+= hpdi32_cable_cmd_mode_6		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Rx Enabled (output)

	errs	+= hpdi32_irq_config_edge		(fd, -1, verbose, 0,								NULL);
	errs	+= hpdi32_irq_config_high		(fd, -1, verbose, -1,								NULL);	// Retain defaults
	errs	+= hpdi32_irq_enable			(fd, -1, verbose, -1,								NULL);	// Retain defaults

	errs	+= hpdi32_rx_auto_start			(fd, -1, verbose, HPDI32_AUTO_START_YES,			NULL);
	errs	+= hpdi32_rx_fifo_ae			(fd, -1, verbose, 256,								NULL);
	errs	+= hpdi32_rx_fifo_af			(fd, -1, verbose, 1024,								NULL);
	errs	+= hpdi32_rx_fifo_overrun		(fd, -1, verbose, HPDI32_FIFO_ERROR_CLEAR,			NULL);
	errs	+= hpdi32_rx_fifo_underrun		(fd, -1, verbose, HPDI32_FIFO_ERROR_CLEAR,			NULL);

	errs	+= hpdi32_rx_enable				(fd, -1, verbose, HPDI32_RX_ENABLE_YES,				NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}


