// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/utils/util_config_tx.c $
// $Rev: 53382 $
// $Date: 2023-07-12 11:12:16 -0500 (Wed, 12 Jul 2023) $

// HPDI32: Utilities: source file

#include "main.h"



//*****************************************************************************
int hpdi32_config_tx(int fd, int index, int verbose)
{
	int	errs	= 0;
	s32	stop;

	if (verbose)
	{
		gsc_label_index("Transmit Configuration", index);
		printf("\n");
		gsc_label_level_inc();
	}

	errs	+= hpdi32_initialize			(fd, -1, verbose);

	// Settings must be applied after the initialization call!

	errs	+= hpdi32_tx_io_bmdma_thresh	(fd, -1, verbose, HPDI32_IO_BMDMA_THRESH_DEFAULT,	NULL);
	errs	+= hpdi32_tx_io_data_size		(fd, -1, verbose, HPDI32_IO_DATA_SIZE_32_BITS,		NULL);
	errs	+= hpdi32_tx_io_mode			(fd, -1, verbose, GSC_IO_MODE_BMDMA,				NULL);
	errs	+= hpdi32_tx_io_pio_threshold	(fd, -1, verbose, 32,								NULL);
	errs	+= hpdi32_tx_io_overrun			(fd, -1, verbose, HPDI32_IO_ERROR_CHECK,			NULL);
	errs	+= hpdi32_tx_io_timeout			(fd, -1, verbose, HPDI32_IO_TIMEOUT_DEFAULT,		NULL);

	errs	+= hpdi32_tristate_te_re		(fd, -1, verbose, HPDI32_TRISTATE_TE_RE_NO,			NULL);
	errs	+= hpdi32_cable_cmd_mode_0		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Frame Valid (output)
	errs	+= hpdi32_cable_cmd_mode_1		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Line Valid (output)
	errs	+= hpdi32_cable_cmd_mode_2		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Status Valid (output)
	errs	+= hpdi32_cable_cmd_mode_3		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Rx Ready (Input, Remote Throttling)
	errs	+= hpdi32_cable_cmd_mode_4		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Tx Ready (output)
	errs	+= hpdi32_cable_cmd_mode_5		(fd, -1, verbose, HPDI32_CABLE_CMD_MODE_FC,			NULL);	// Tx Enabled (output)

	errs	+= hpdi32_irq_config_edge		(fd, -1, verbose, 0,								NULL);
	errs	+= hpdi32_irq_config_high		(fd, -1, verbose, -1,								NULL);	// Retain defaults
	errs	+= hpdi32_irq_enable			(fd, -1, verbose, -1,								NULL);	// Retain defaults
	errs	+= hpdi32_tx_clock_divider		(fd, -1, verbose, 0,								NULL);
	errs	+= hpdi32_tx_auto_start			(fd, -1, verbose, HPDI32_AUTO_START_YES,			NULL);

	errs	+= hpdi32_query					(fd, -1, 0, HPDI32_QUERY_TX_AUTO_STOP, &stop);

	if (stop)
		errs	+= hpdi32_tx_auto_stop		(fd, -1, verbose, HPDI32_AUTO_STOP_NO,				NULL);

	errs	+= hpdi32_tx_line_val_off_cnt	(fd, -1, verbose, 0,								NULL);
	errs	+= hpdi32_tx_line_val_on_cnt	(fd, -1, verbose, 0,								NULL);
	errs	+= hpdi32_tx_remote_throttle	(fd, -1, verbose, HPDI32_TX_REMOTE_THROTTLE_NO,		NULL);
	errs	+= hpdi32_tx_status_val_cnt		(fd, -1, verbose, 0,								NULL);
	errs	+= hpdi32_tx_status_val_mir		(fd, -1, verbose, HPDI32_TX_STATUS_VAL_MIR_NO,		NULL);
	errs	+= hpdi32_tx_fifo_ae			(fd, -1, verbose, 256,								NULL);
	errs	+= hpdi32_tx_fifo_af			(fd, -1, verbose, 1024,								NULL);
	errs	+= hpdi32_tx_fifo_overrun		(fd, -1, verbose, HPDI32_FIFO_ERROR_CLEAR,			NULL);
	errs	+= hpdi32_tx_flow_control		(fd, -1, verbose, HPDI32_TX_FLOW_CONTROL_STOP,		NULL);
	errs	+= hpdi32_tx_enable				(fd, -1, verbose, HPDI32_TX_ENABLE_YES,				NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}


