// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/utils/util_rx_io_bmdma_thresh.c $
// $Rev: 48420 $
// $Date: 2020-11-06 16:40:51 -0600 (Fri, 06 Nov 2020) $

// HPDI32: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hpdi32_rx_io_bmdma_thresh
*
*	Purpose:
*
*		Provide a visual wrapper for the HPDI32_IOCTL_RX_IO_BMDMA_THRESH service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hpdi32_rx_io_bmdma_thresh(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Rx I/O BMDMA Threshold", index);

	ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_RX_IO_BMDMA_THRESH, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s  (%ld byte%s)\n",
				errs ? "FAIL <---" : "PASS",
				(long) set,
				(set == 1) ? "" : "s");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


