// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/utils/util_rx_line_count.c $
// $Rev: 46444 $
// $Date: 2019-09-09 18:18:58 -0500 (Mon, 09 Sep 2019) $

// HPDI32: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hpdi32_rx_line_count
*
*	Purpose:
*
*		Provide a visual wrapper for the HPDI32_IOCTL_RX_LINE_COUNT service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hpdi32_rx_line_count(int fd, int index, int verbose, s32* get)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("Rx Line Count", index);

	ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_RX_LINE_COUNT, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s  (%ld clock cycle%s)\n",
			errs ? "FAIL <---" : "PASS",
			(long) set,
			(set == 1) ? "" : "s");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


