// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_2.x.x.x_GSC_DN/utils/util_tx_clock_divider.c $
// $Rev: 51575 $
// $Date: 2022-10-04 17:47:45 -0500 (Tue, 04 Oct 2022) $

// HPDI32: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hpdi32_tx_clock_divider
*
*	Purpose:
*
*		Provide a visual wrapper for the HPDI32_IOCTL_TX_CLOCK_DIVIDER service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hpdi32_tx_clock_divider(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Tx Clock Divider", index);

	ret		= hpdi32_ioctl(fd, HPDI32_IOCTL_TX_CLOCK_DIVIDER, &set);
	errs	= ret ? 1 : 0;

	if (verbose == 0)
	{
	}
	else if (set == -1)
	{
		printf("(Feature unsupported on this device.)\n");
	}
	else
	{
		printf(	"%s  (%ld -> /%ld)\n",
			errs ? "FAIL <---" : "PASS",
			(long) set,
			(long) ((set <= 0) ? 1 : set * 2));
	}

	if (get)
		get[0]	= set;

	return(errs);
}


